
package org.act.wsc.bpel4wsmodeling.debug.engine;
import java.net.MalformedURLException;
import java.rmi.RemoteException;
import java.util.List;
import javax.xml.namespace.QName;
import javax.xml.rpc.encoding.XMLType;
import org.act.metaset.Metaset;
import org.act.services.workflow.debug.Debug;
import org.act.services.workflow.debug.IDebugEngineListener;
import org.act.wswf.WSWFRuntime;
import org.apache.axis.client.Call;
import org.apache.axis.message.SOAPHeaderElement;

public class WSWF {
 
	
	public static void start(String debugPath) {
		Debug.clean();
		Debug.setDebug(true);
		Debug.setDebugPath(debugPath);
		WSWFRuntime.getWSRuntime().start();
	}
	
	public static void stop() {
		Debug.clean();
		SOAPHeaderElement element = new SOAPHeaderElement("", "ManageID",
		"000001");
		String SERVICE_URI = "http://127.0.0.1:8091/SystemInfo";
	    	    Call call;
        try {
            call = new Call(SERVICE_URI);
            call.setTargetEndpointAddress(
	        "http://localhost:8091/SystemInfo");
	    call.setOperationName(new QName("", "shutdown"));
	    call.addHeader(element);
	    call.setReturnType(XMLType.XSD_BOOLEAN);
	    try {
                        call.invoke(new Object[0]);
        } catch (RemoteException e1) {
                        e1.printStackTrace();
        }
        } catch (MalformedURLException e) {
                        e.printStackTrace();
        }
        
	    	}
	
	public static void restart(List idList) {
		Debug.restart(idList);
	}
	
	public static void addListener(IDebugEngineListener listener) {
		Debug.getListeners().add(listener);
	}
	
	public static void removeListener(IDebugEngineListener listener) {
		Debug.getListeners().remove(listener);
	}
	
	public static void setVarPartValue(String varName, String partName,
			String value) {
		Debug.setVarPartValue(varName, partName, value);
	}
	
	public static String getVarPartValue(String varName, String partName) {
		return Debug.getVarPartValue(varName, partName);
	}
	
								public static Metaset getVars() {
		return Debug.getVars();
	}
	
	public static boolean inStack(String id) {
		return Debug.inStack(id);
	}
	
	public static void replace(Metaset activity, String id) {
		Debug.replace(activity, id);
	}
	
	public static boolean setDebug(String id) {
		if (Debug.getRc() != null) {
					}
		return true;
	}
}
