package org.act.wsc.bpel4wsmodeling.def.process;
import org.act.metaset.Attribute;
import org.act.metaset.Metaset;
import org.act.wsc.bpel4wsmodeling.utils.CreateDebugId;
//<p></p><p></p><p></p><p></p>
public class Case
    extends Metaset {
  Attribute condition;
    Attribute debugId;
  Activity act = null;
  public Case() {
    super("case");
    this.condition = new Attribute("condition", "");
        this.debugId = new Attribute("debugId", CreateDebugId.getDebugId());
        this.add(this.debugId);
    this.add(this.condition);
  }
  public void setAtConditionValue(String s) {
    this.condition.setValue(s);
  }
  public String getAtConditionValue() {
    return this.condition.getValue();
  }
    public void setAtDebugIdValue(String s) {
      this.debugId.setValue(s);
  }
    public String getAtDebugIdValue() {
      return this.debugId.getValue();
  }
  public void addActivity(Activity activity) {
    if (this.filter(".\\*") == null) {
      this.add(activity);
      activity.setFather(this) ;
      this.act = activity;
    }
  }
  public void deleteActivity(Activity activity) {
    this.remove(activity);
  }
  public void deleteActivity() {
    if (this.act != null) {
      this.remove(act);
    }
  }
  public Activity getActivity() {
    if (this.filter(".\\invoke") != null) {
      return (Invoke)this.filter(".\\invoke").car();
    }
    if (this.filter(".\\receive") != null) {
      return (Receive)this.filter(".\\receive").car();
    }
    if (this.filter(".\\reply") != null) {
      return (Reply)this.filter(".\\reply").car();
    }
    if (this.filter(".\\assign") != null) {
      return (Assign)this.filter(".\\assign").car();
    }
    if (this.filter(".\\wait") != null) {
      return (Wait)this.filter(".\\wait").car();
    }
    if (this.filter(".\\throw") != null) {
      return (Throw)this.filter(".\\throw").car();
    }
    if (this.filter(".\\scope") != null) {
      return (Scope)this.filter(".\\scope").car();
    }
    if (this.filter(".\\sequence") != null) {
      return (Sequence)this.filter(".\\sequence").car();
    }
    if (this.filter(".\\while") != null) {
      return (While)this.filter(".\\while").car();
    }
    if (this.filter(".\\switch") != null) {
      return (Switch)this.filter(".\\switch").car();
    }
    if (this.filter(".\\flow") != null) {
      return (Flow)this.filter(".\\flow").car();
    }
    if (this.filter(".\\pick") != null) {
      return (Pick)this.filter(".\\pick").car();
    }
    if (this.filter(".\\empty") != null) {
      return (Empty)this.filter(".\\empty").car();
    }
    if (this.filter(".\\compensate") != null) {
      return (Compensate)this.filter(".\\compensate").car();
    }
    if (this.filter(".\\terminate") != null) {
      return (Terminate)this.filter(".\\terminate").car();
    }
    return null;
  }
  public void addAtt(Attribute att) {
    this.add(att);
  }
  public void deleteAtt(Attribute att) {
    this.remove(att);
  }
}
