package org.act.wsc.bpel4wsmodeling.def.process;
import java.util.Iterator;
import org.act.metaset.Attribute;
import org.act.metaset.Metaset;
import org.act.wsc.bpel4wsmodeling.bpeldata.listener.IActivityChildListener;
//<p></p><p></p><p></p><p></p>
public class Receive
    extends Activity {
  Attribute partnerLink;
  Attribute portType;
  Attribute operation;
  Attribute variable;
  Attribute createInstance;
  public Receive() {
    super();
    this.setName("receive") ;
    partnerLink = new Attribute("partnerLink", "");
    portType = new Attribute("portType", "");
    operation = new Attribute("operation", "");
    variable = new Attribute("variable", "");
    createInstance = new Attribute("createInstance", "");
    this.add(partnerLink);
    this.add(portType);
    this.add(operation);
    this.add(variable);
    this.add(createInstance);
  }
  public void setAtPartnerLinkValue(String s) {
    this.partnerLink.setValue(s);
  }
  public String getAtPartnerLinkValue() {
    return this.partnerLink.getValue();
  }
  public void setAtPortTypeValue(String s) {
    this.portType.setValue(s);
  }
  public String getAtPortTypeValue() {
    return this.portType.getValue();
  }
  public void setAtOperationValue(String s) {
    this.operation.setValue(s);
  }
  public String getAtOperationValue() {
    return this.operation.getValue();
  }
  public void setAtVariableValue(String s) {
    this.variable.setValue(s);
  }
  public String getAtVariableValue() {
    return this.variable.getValue();
  }
  public void setAtcreateInstanceValue(String s) {
    this.createInstance.setValue(s);
  }
  public String getAtCreateInstanceValue() {
    return this.createInstance.getValue();
  }
  public void addCorrelations(Correlations correlations) {
    if(this.filter(".\\correlations")==null) {
      this.add(correlations);
      correlations.setFather(this) ;
    }
  }
  public Metaset getCorrelations() {
    return this.filter(".\\correlations") ;
  }
  public void addCorrelation(Correlation correlation) {
  Correlations correlations;
  if (this.filter(".\\correlations") == null) {
    correlations = new Correlations();
    this.add(correlations);
    correlations.setFather(this);
  }
  else {
    correlations = (Correlations)this.getCorrelations().car();
  }
  if(correlations.addCorrelation(correlation)==true){
      fireCorrelationAdded(correlation);   
  }
}
  
  private void fireCorrelationAdded(Correlation correlation) {
  	      for (Iterator iter = this.childListeners.iterator(); iter.hasNext(); ) {
      	IActivityChildListener element = (IActivityChildListener) iter.next();
          element.addCorrelation( correlation);
        }
  }
  public void deleteCorrelation(Correlation correlation) {
      fireCorrelationDeleted(correlation);
    	Correlations correlations = (Correlations)this.getCorrelations() .car() ;
    	correlations.deleteCorrelation(correlation);
      if (correlations.getChilds().size() == 0) {
      	this.detelteCorrelations( correlations);
      }
    }
    
  private void fireCorrelationDeleted(Correlation correlation) {
  	      for (Iterator iter = this.childListeners.iterator(); iter.hasNext(); ) {
      	IActivityChildListener element = (IActivityChildListener) iter.next();
          element.deleteCorrelation(correlation );
        }
  }
  public void detelteCorrelations(  Correlations correlations) {
     this.remove(correlations ) ;
    }
}
