
package org.act.wsc.bpel4wsmodeling.projectdata.process;
import java.awt.Point;
import java.util.Iterator;
import java.util.List;
import java.util.Vector;

public class Line {
	public static int LINE_HEIGHT=10;
	Figure source=null;
	Figure target=null;
	List points=new Vector();
	protected Line() {
		super();
		
	}
	
	public Figure getSource() {
		return source;
	}
	
	public void setSource(Figure source) {
		if(this.source==null){
			this.points.add(0,new Point(source.getX(),source.getY()+source.getHeight()));
		}
		else{
			this.points.set(0,new Point(source.getX(),source.getY()+source.getHeight()));
		}
			this.source = source;
			source.setOutput(this);
	}
	
	public Figure getTarget() {
		return target;
	}
	
	public void setTarget(Figure target) {
		if(this.target==null){
			this.points.add(new Point(target.getX(),target.getY()));
		}
		else{
			this.points.set(this.points.size()-1,new Point(target.getX(),target.getY()));
		}
		this.target = target;
		target.setInput(this);	
	}
	
	public List getPoints() {
		return points;
	}
	
	public void translate(int dx,int dy){
		for (Iterator iter = this.points.iterator(); iter.hasNext();) {
			Point element = (Point) iter.next();
			element.translate(dx,dy);
		}
	}
	
	protected void reset(){
		this.points.clear();
		this.source=null;
		this.target=null;
	}
}
