
package org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define;
import java.util.List;
import java.util.Map;
import java.util.Vector;
import javax.wsdl.BindingInput;
import javax.wsdl.extensions.ExtensibilityElement;
import javax.xml.namespace.QName;
import org.w3c.dom.Element;

public class BindingInputEx extends WSDLLabel implements IDerivedLabel,BindingInput {
    String name;
    List extensibilityElements=new Vector();
    InputEx inputEx;
    
    public static final String ATT_NAME = "name";
    
    public BindingInputEx() {
        super();
    }
    
    
    public boolean addChild(WSDLLabel childLabel) {
        return false;
    }
    
    public boolean removeChild(WSDLLabel childLabel) {
        if (childLabel instanceof ExtensibilityElementEx) {
            this.removeExtensibilityElement((ExtensibilityElementEx) childLabel);
            return true;
        }
        return false;
    }
    
    
    
    
    public void addExtensibilityElement(ExtensibilityElement extensibilityElement) {
        this.extensibilityElements.add(extensibilityElement);
        if (extensibilityElement instanceof ExtensibilityElementEx) {
            ExtensibilityElementEx new_name = (ExtensibilityElementEx) extensibilityElement;
            this.fireChildAdded(new_name);
        }
    }
    
    public void removeExtensibilityElement(ExtensibilityElement extensibilityElement) {
        this.extensibilityElements.remove(extensibilityElements);
        if (extensibilityElement instanceof ExtensibilityElementEx) {
            ExtensibilityElementEx new_name = (ExtensibilityElementEx) extensibilityElement;
            this.fireChildRemoved(new_name);
        }
    }
    
    public Element getDocumentationElement() {
                return null;
    }
    
    public List getExtensibilityElements() {
        
        return this.extensibilityElements;
    }
    
    public void setDocumentationElement(Element arg0) {
                
    }
    
    public String getName() {
        if(this.name==null){
            this.name=this.getLabelName();
        }
        return this.name;
    }
    
    public void setName(String name) {
        String oldName=this.name;
        if(oldName==null||oldName.equals(name)){
            this.name=name;
            this.firePropertyChanged(this);
        }
    }
    public void reName(String newName){
        if(newName==null){
            return;
        }
        String oldName=this.getName();
        this.setName(newName);
        if(!newName.equals(oldName)){
            this.fireChildRenamed(this);
        }
    }
    
    public InputEx getInputEx() {
        return inputEx;
    }
    
    public void setInputEx(InputEx inputEx) {
        this.inputEx = inputEx;
    }
    
    public Object getExtensionAttribute(QName arg0) {
                return null;
    }
    
    public Map getExtensionAttributes() {
                return null;
    }
    
    public List getNativeAttributeNames() {
                return null;
    }
    
    public void setExtensionAttribute(QName arg0, Object arg1) {
                
    }
}
