
package org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Vector;
import javax.wsdl.Message;
import javax.wsdl.Part;
import javax.xml.namespace.QName;
import org.w3c.dom.Element;

public class MessageEx extends WSDLLabel implements IDerivedLabel,Message {
    public static final String ATT_NAME="name";
    public static int timer=0;
    
    private QName name=null;
    Map parts=new HashMap();
        List partList=new Vector();
    
    
    public MessageEx() {
        super();
            }
   
    
    public boolean addChild(WSDLLabel childLabel) {
        if (childLabel instanceof PartEx) {
			
			this.fireChildAdded(childLabel);
		}
        return false;
    }
    
    public boolean removeChild(WSDLLabel childLabel) {
        if(childLabel instanceof PartEx){
            this.removePart((PartEx)childLabel);
            return true;
        }
        return false;
    }
  
    
    
    public void addPart(Part part) {
        if (part instanceof PartEx) {
            PartEx partEx = (PartEx) part;
            partEx.setMessageEx(this);
            this.partList.add(partEx);
            this.parts.put(partEx.getName(),part);
            this.fireChildAdded(partEx);
        }
    }
    public void removePart(Part part) {
        if (part instanceof PartEx) {
            PartEx partEx = (PartEx) part;
            this.partList.remove(partEx);
            this.parts.remove(partEx.getName());
            this.fireChildRemoved(partEx);
        }
    }
    
    public Element getDocumentationElement() {
                return null;
    }
    
    public List getOrderedParts(List arg0) {
                return null;
    }
    
    public Part getPart(String partName) {
        
        return (Part) this.parts.get(partName);
    }
    
    public Map getParts() {
        
        return this.parts;
    }
    
    public QName getQName() {
        if(this.name==null){
            this.name=this.definitionEx.StringToQName(this.getLabelName());
        }
        return this.name;
    }
    
    public boolean isUndefined() {
                return false;
    }
    
    public void setDocumentationElement(Element arg0) {
                
    }
    
    public void setQName(QName name) {
        QName oldName=this.name;
        if(oldName==null||!oldName.equals(name)){
            this.name=name;
            this.firePropertyChanged(this);
        }
    }
    public void reName(String newName){
        if(newName==null){
            return;
        }
        QName oldQName=this.getQName();
        QName newQName=this.definitionEx.StringToQName(newName);
        this.name=newQName;
        if(!newQName.equals(oldQName)){
            this.getDefinitionEx().messages.remove(oldQName);
            this.getDefinitionEx().messages.put(newQName,this);
            this.fireChildRenamed(this);
            this.firePropertyChanged(this);
        }
    }
    
    public void setUndefined(boolean arg0) {
                
    }
    
    public String getName() {
        return this.definitionEx.QNameToString(this.getQName());
    }
    
    public Object getExtensionAttribute(QName arg0) {
                return null;
    }
    
    public Map getExtensionAttributes() {
                return null;
    }
    
    public List getNativeAttributeNames() {
                return null;
    }
    
    public void setExtensionAttribute(QName arg0, Object arg1) {
                
    }
    
    public List getPartList() {
        return partList;
    }
}
