
package org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.view.popmenu;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.JMenu;
import javax.swing.JMenuItem;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.BindingInputEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.HTTPUrlEncoded;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.HTTPUrlReplacement;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.MIMEContent;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.MIMEMultipartRelated;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.MIMEXml;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.view.MyTreeNode;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.view.propertyeditor.PropertyEditorFactory;

public class BindingHTTPInputRightMenu extends AbstractTreeRightMenu {
    
	
    JMenu addExtensibilityElement=new JMenu("ExtensibilityElement");
    JMenuItem addHTTPUrlEncoded = new JMenuItem("http:urlEncoded");
    JMenuItem addHTTPUrlReplacement = new JMenuItem("http:urlReplacement");
    JMenuItem addMIMEContent = new JMenuItem("mime:content");
    JMenuItem addMIMEMultipartRelated = new JMenuItem("mime:multipartRelated");
    JMenuItem addMIMEXml = new JMenuItem("mime:mimeXml");
    JMenuItem setName = new JMenuItem("name");
    private void jbInit() throws Exception  {
    	addExtensibilityElement.add(addHTTPUrlEncoded);
    	addExtensibilityElement.add(addHTTPUrlReplacement);
    	addExtensibilityElement.add(addMIMEContent);
    	addExtensibilityElement.add(addMIMEMultipartRelated);
    	addExtensibilityElement.add(addMIMEXml);
     }
    
    
    public BindingHTTPInputRightMenu(MyTreeNode myTreeNode) {
        super(myTreeNode);
        if (myTreeNode.getWsdlLabel() instanceof BindingInputEx) {
            final BindingInputEx bindingInputEx = (BindingInputEx) myTreeNode
                    .getWsdlLabel();
            this.setName.addActionListener(new ActionListener() {
                String initialV = bindingInputEx.getName();
                public void actionPerformed(ActionEvent e) {
                    String result = PropertyEditorFactory.showEditor(
                            BindingInputEx.ATT_NAME + ": ", ""
                                    + BindingInputEx.ATT_NAME, initialV);
                    if(result!=null){
                        bindingInputEx.setName(result);
                    }
                    
                }
            });
            this.add(setName);
            this.add(this.addExtensibilityElement);
            
               this.addHTTPUrlReplacement.addActionListener(new ActionListener(){
                   public void actionPerformed(ActionEvent e) {
                          HTTPUrlReplacement httpUrlReplacement=(HTTPUrlReplacement)bindingInputEx.getDefinitionEx().createHTTPUrlReplacement();
                           bindingInputEx.addExtensibilityElement(httpUrlReplacement);
                   }});
               
               this.addHTTPUrlEncoded.addActionListener(new ActionListener(){
                   public void actionPerformed(ActionEvent e) {
                          HTTPUrlEncoded httpUrlEncoded=(HTTPUrlEncoded)bindingInputEx.getDefinitionEx().createHTTPUrlEncoded();
                           bindingInputEx.addExtensibilityElement(httpUrlEncoded);
                   }});
               
               this.addMIMEContent.addActionListener(new ActionListener(){
                   public void actionPerformed(ActionEvent e) {
                          MIMEContent mimeContent=(MIMEContent)bindingInputEx.getDefinitionEx().createMIMEContent();
                           bindingInputEx.addExtensibilityElement(mimeContent);
                   }});
               
               this.addMIMEMultipartRelated.addActionListener(new ActionListener(){
                   public void actionPerformed(ActionEvent e) {
                          MIMEMultipartRelated mimeMultipartRelated=(MIMEMultipartRelated)bindingInputEx.getDefinitionEx().createMIMEMultipartRelated();
                           bindingInputEx.addExtensibilityElement(mimeMultipartRelated);
                   }});
               
               this.addMIMEXml.addActionListener(new ActionListener(){
                   public void actionPerformed(ActionEvent e) {
                          MIMEXml mimeXml=(MIMEXml)bindingInputEx.getDefinitionEx().createMIMEXml();
                           bindingInputEx.addExtensibilityElement(mimeXml);
                   }});
        }
        this.add(this.removeItem);
        try {
			jbInit() ;
		} catch (Exception e1) {
						e1.printStackTrace();
		}
    }
}
