
package org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.view.popmenu;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ResourceBundle;
import javax.swing.JMenu;
import javax.swing.JMenuItem;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.BindingFaultEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.BindingOperationEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.FaultEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.SOAPFault;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.view.MyTreeNode;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.view.propertyeditor.PropertyEditorFactory;
import org.act.wsc.bpel4wsmodeling.view.resource.ResChoose;

public class BindingSOAPFaultRightMenu extends AbstractTreeRightMenu {
	  private ResourceBundle res = ResChoose.getLanguage();
	  
	
    JMenu addExtensibilityElement=new JMenu(res.getString("BSOAPFRM_AExtensibilityElement"));
    JMenuItem addSOAPFault = new JMenuItem(res.getString("BSOAPFRM_AFault"));
    JMenuItem setName=new JMenuItem(res.getString("BSOAPFRM_SetName"));
   
    
    private void jbInit() throws Exception  {
    	addExtensibilityElement.add(addSOAPFault);
    	
     }
    
    
    public BindingSOAPFaultRightMenu(MyTreeNode myTreeNode) {
        super(myTreeNode);
        if (myTreeNode.getWsdlLabel() instanceof BindingFaultEx) {
            final BindingFaultEx bindingFaultEx = (BindingFaultEx) myTreeNode.getWsdlLabel();
            final BindingOperationEx bindingOperationEx = (BindingOperationEx)((MyTreeNode) myTreeNode.getParent()).getWsdlLabel();
            this.setName.addActionListener(new ActionListener(){
                public void actionPerformed(ActionEvent e) {
                    String initialV=bindingFaultEx.getName();
                    String result=PropertyEditorFactory.showEditor(BindingFaultEx.ATT_NAME+": ",""+BindingFaultEx.ATT_NAME,initialV);
                    if(result!=null){
                        bindingFaultEx.setName(result);
                        bindingFaultEx.setFaultEx((FaultEx) bindingOperationEx.getOperation().getFault(result));
                    }
                }});
            this.add(setName);
            
            this.add(this.addExtensibilityElement);
         
            this.addSOAPFault.addActionListener(new ActionListener(){
                public void actionPerformed(ActionEvent e) {
                   
                       SOAPFault soapFault=(SOAPFault)bindingFaultEx.getDefinitionEx().createSOAPFault();
                        bindingFaultEx.addExtensibilityElement(soapFault);
                }});
           
            
        }
        
        this.add(this.removeItem);
        try {
			jbInit() ;
		} catch (Exception e1) {
						e1.printStackTrace();
		}
    }
}
