
package org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.view.popmenu;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ResourceBundle;
import javax.swing.JMenuItem;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.HTTPOperation;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.view.MyTreeNode;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.view.propertyeditor.PropertyEditorFactory;
import org.act.wsc.bpel4wsmodeling.view.resource.ResChoose;

public class HTTPOperationRightMenu extends AbstractTreeRightMenu {
	private ResourceBundle res = ResChoose.getLanguage();
   JMenuItem setLocation=new JMenuItem(res.getString("HTTPOPRM_SetLocation"));
   
    
    public HTTPOperationRightMenu(MyTreeNode myTreeNode) {
        super(myTreeNode);
        if (myTreeNode.getWsdlLabel() instanceof HTTPOperation) {
            final HTTPOperation operation = (HTTPOperation) myTreeNode.getWsdlLabel();
            
            this.setLocation.addActionListener(new ActionListener(){
                public void actionPerformed(ActionEvent e) {
                    String initialV=operation.getLocation();
                    String result=PropertyEditorFactory.showEditor(HTTPOperation.ATT_LOC+": ",res.getString("HTTPOPRM_Set")+HTTPOperation.ATT_LOC,initialV);
                }});
            this.add(setLocation);
        }
        
               this.add(this.removeItem);
    }
}
