
package org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.view.popmenu;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ResourceBundle;
import javax.swing.JMenuItem;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.MIMEContent;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.MIMEMultipartRelated;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.MIMEPart;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.MIMEXml;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.WSDLLabel;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.view.MyTreeNode;
import org.act.wsc.bpel4wsmodeling.view.resource.ResChoose;
 
public class MIMEPartRightMenu extends AbstractTreeRightMenu {
	
	private ResourceBundle res = ResChoose.getLanguage();
    
	JMenuItem addMIMEMultipartRelated=new JMenuItem(res.getString("MIMEPRM_AMultipartRelated"));
	JMenuItem addMIMEContent=new JMenuItem(res.getString("MIMEPRM_AContent"));
	JMenuItem addMIMEXml=new JMenuItem(res.getString("MIMEPRM_AXML"));
    
   
    
    
    public MIMEPartRightMenu(MyTreeNode myTreeNode) {
        super(myTreeNode);
        
       
      
         this.addMIMEXml.addActionListener(new ActionListener(){
            public void actionPerformed(ActionEvent e) {
            	
                WSDLLabel label=MIMEPartRightMenu.this.myTreeNode.getWsdlLabel();
                if (label instanceof MIMEPart) {
                	MIMEPart mimePart = (MIMEPart) label;
                	MIMEXml mimeXml=(MIMEXml)mimePart.getDefinitionEx().createMIMEXml();
                	mimePart.addExtensibilityElementEx(mimeXml);
                }
                
            }});
         this.addMIMEContent.addActionListener(new ActionListener(){
            public void actionPerformed(ActionEvent e) {
            	
                WSDLLabel label=MIMEPartRightMenu.this.myTreeNode.getWsdlLabel();
                if (label instanceof MIMEPart) {
                	MIMEPart mimePart = (MIMEPart) label;
                	MIMEContent mimeContent=(MIMEContent)mimePart.getDefinitionEx().createMIMEContent();
                	mimePart.addExtensibilityElementEx(mimeContent);
                }
                
            }});
         
         this.addMIMEMultipartRelated.addActionListener(new ActionListener(){
            public void actionPerformed(ActionEvent e) {
            	
                WSDLLabel label=MIMEPartRightMenu.this.myTreeNode.getWsdlLabel();
                if (label instanceof MIMEPart) {
                	MIMEPart mimePart = (MIMEPart) label;
                	MIMEMultipartRelated mimeMultipartRelated=(MIMEMultipartRelated)mimePart.getDefinitionEx().createMIMEMultipartRelated();
                	mimePart.addExtensibilityElementEx(mimeMultipartRelated);
                }
                
            }});
         
         
         
        this.add(addMIMEMultipartRelated);
        this.add(addMIMEContent);
        this.add(addMIMEXml);
        
    }
}
