
package org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.view.popmenu;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ResourceBundle;
import javax.swing.JMenuItem;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.SimpleTypeEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.view.MyTreeNode;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.view.propertyeditor.PropertyEditorFactory;
import org.act.wsc.bpel4wsmodeling.view.resource.ResChoose;

public class SimpleTypeRightMenu extends AbstractTreeRightMenu {
	private ResourceBundle res = ResChoose.getLanguage();
    JMenuItem setName = new JMenuItem(res.getString("STRM_SetName"));
    JMenuItem addSetRestriction = new JMenuItem(res.getString("STRM_SetRestrict"));
    
    public SimpleTypeRightMenu(MyTreeNode myTreeNode) {
        super(myTreeNode);
        if (SimpleTypeRightMenu.this.myTreeNode.getWsdlLabel() instanceof SimpleTypeEx) {
            final SimpleTypeEx simpleTypeEx = (SimpleTypeEx) SimpleTypeRightMenu.this.myTreeNode
                    .getWsdlLabel();
            this.setName.addActionListener(new ActionListener() {
                public void actionPerformed(ActionEvent e) {
                    String initialV = simpleTypeEx.getName();
                    String result = PropertyEditorFactory.showEditor(
                            SimpleTypeEx.ATT_NAME + ": ", res.getString("STRM_Set") + SimpleTypeEx.ATT_NAME,
                            initialV);
                    simpleTypeEx.setName(result);
                }
            });
            this.add(this.setName);
            this.add(this.addSetRestriction);
            this.addSetRestriction.addActionListener(new ActionListener() {
                public void actionPerformed(ActionEvent e) {
                    PropertyEditorFactory.showSimpleTypePropertyEditor(simpleTypeEx);
                }
            });
        }
        this.add(this.removeItem);
    }
}
