
package org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.view.popmenu;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ResourceBundle;
import javax.swing.JMenuItem;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.DefinitionEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.SchemaEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.TypesEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.WSDLLabel;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.view.MyTreeNode;
import org.act.wsc.bpel4wsmodeling.view.resource.ResChoose;

public class TypesRightMenu extends AbstractTreeRightMenu {
	
	private ResourceBundle res = ResChoose.getLanguage();
	DefinitionEx types = new DefinitionEx();
	
	
	JMenuItem addItem=new JMenuItem(res.getString("TRM_ASchema"));
    
    
	 public TypesRightMenu(MyTreeNode myTreeNode) {
        super(myTreeNode);
        this.add(this.addItem);
        this.addItem.addActionListener(new ActionListener(){
            public void actionPerformed(ActionEvent e) {
            	WSDLLabel label=((MyTreeNode) TypesRightMenu.this.myTreeNode.getParent()).getWsdlLabel();
                if(label instanceof DefinitionEx){
                    DefinitionEx definitionEx=(DefinitionEx)label;  
                                        if(definitionEx.getTypes()==null){
                    	definitionEx.addTypes((TypesEx) definitionEx.createTypes());
                    }
                    SchemaEx schemaEx=(SchemaEx)definitionEx.createSchema();
                    schemaEx.setTargetNamespace("http://www.act.org/userdefined/schema");
                    schemaEx.addNamespace("xsd","http://www.w3.org/2001/XMLSchema");
                    ((TypesEx)definitionEx.getTypes()).addExtensibilityElement(schemaEx);
                }
            }            
        });
    }
}
	
	
	
	
	
	
	
	
	
	
	
	
    
                        
                  
   