
package org.act.wsc.bpel4wsmodeling.utils;
import java.text.DateFormat;
import java.util.Date;
import java.util.ResourceBundle;
import org.act.wsc.bpel4wsmodeling.view.gui.*;
import org.act.wsc.bpel4wsmodeling.view.resource.ResChoose;

public class Print {
	 static ResourceBundle res = ResChoose.getLanguage();
    
    public Print() {
        super();
            }
    public static final int MESSAGE_TYPE_DEBUG = -1;
    public static final int MESSAGE_TYPE_MESSAGE = 0;
    public static final int MESSAGE_TYPE_WARNING = 1;
    public static final int MESSAGE_TYPE_ERROR = 2;
    public static final int MESSAGE_TYPE_FATAL_ERROR = 3;
    private static MainFrame mainFrame =null;
    public static void setMainFrame(MainFrame frame) {
      if(mainFrame == null)
        mainFrame = frame;
    }
    public static void showMessage(String msg) {
      Print.showMessage(msg, Print.MESSAGE_TYPE_MESSAGE);
    }
    public static void showMessage(String msg, int msgType) {
      Date now = new Date();
      DateFormat df = DateFormat.getDateTimeInstance();
      String rmsg = "[" + df.format(now) + "] " + Print.getTypeName(msgType) + msg;
            MainFrame.getmainFrame().getOutputWindow().getMessagePane().printMessage(rmsg);
    }
    public static String getTypeName(int msgType) {
      switch(msgType) {
        case Print.MESSAGE_TYPE_DEBUG:
          return res.getString("[debug")+" ";
        case Print.MESSAGE_TYPE_ERROR:
          return res.getString("[error")+" ";
        case Print.MESSAGE_TYPE_FATAL_ERROR:
          return res.getString("[seriousError")+" " ;
        case Print.MESSAGE_TYPE_MESSAGE:
          return res.getString("[meseage")+" ";
        case Print.MESSAGE_TYPE_WARNING:
          return res.getString("[warning")+" ";
      }
      return res.getString("[unknown")+" ";
    }
}
