package org.act.wsc.bpel4wsmodeling.view.graphic.leftbuttonproperty;
import javax.swing.JTable;
import javax.swing.table.DefaultTableModel;
import org.act.wsc.bpel4wsmodeling.def.process.BPELProcess;
import org.act.wsc.bpel4wsmodeling.projectdata.process.Figure;
//<p></p><p></p><p></p><p></p>
public abstract class AbstractLeftProperty {
  protected Figure figure;
  BPELProcess process;
  JTable jAttTable;
  DefaultTableModel defaultAttTableModel;
  public AbstractLeftProperty(Figure figure) {
    this.figure = figure;
    this.process = figure.getOwner().getBPELProcess();
    defaultAttTableModel = new DefaultTableModel() {
      public boolean isCellEditable(int row, int column) {
        return column == 1;
      }
    };
    jAttTable = new JTable(defaultAttTableModel);
  }
  abstract void initAttTable();
  abstract public void setAttTable();
  public JTable getAttTable() {
    return this.jAttTable;
  }
}
