package org.act.wsc.bpel4wsmodeling.view.graphic.leftbuttonproperty;
import javax.swing.JPopupMenu;
import javax.swing.JMenuItem;
import org.act.wsc.bpel4wsmodeling.view.gui.MainFrame;
import org.act.wsc.bpel4wsmodeling.view.processassist.CorrelationDialog;
import org.act.wsc.bpel4wsmodeling.view.resource.ResChoose;
import org.act.wsc.bpel4wsmodeling.projectdata.process.Figure;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.awt.Dimension;
import java.util.ResourceBundle;
import org.act.wsc.bpel4wsmodeling.def.process.BPELProcess;
import org.act.wsc.bpel4wsmodeling.def.process.Correlation;
import org.act.wsc.bpel4wsmodeling.def.process.Invoke;
//<p></p><p></p><p></p><p></p>
public class InvokePropertyRightMenu
    extends JPopupMenu {
	 ResourceBundle res = ResChoose.getLanguage();
  private JMenuItem editProperty = new JMenuItem(res.getString("editproperty"));
  private JMenuItem delete = new JMenuItem(res.getString("delete"));
  MainFrame frame = MainFrame.getmainFrame();
  Correlation correlation;
  Invoke invoke;
  Figure figure;
  BPELProcess process;
  public InvokePropertyRightMenu(Correlation c, Figure f) {
    this.correlation = c;
    this.figure = f;
    this.invoke =(Invoke) this.figure .getServicesSet() ;
    this.process = f.getOwner().getBPELProcess();
    this.add(this.editProperty);
    this.add(this.delete);
    this.editProperty.addMouseListener(new MouseAdapter() {
      public void mouseReleased(MouseEvent e) {
        if (e.getButton() == 1 && e.getClickCount() == 1) {
          CorrelationDialog cDialog = new CorrelationDialog(frame,figure);
          cDialog.setCorrelation(correlation) ;
          cDialog.setSize(new Dimension(400, 350));
          cDialog.setLocation( (frame.getWidth() -
                                     cDialog.getWidth()) /
                                   2,
                                   (frame.getHeight() -
                                    cDialog.getHeight()) /
                                   2);
          cDialog.show();
        }
      }
    });
    this.delete.addMouseListener(new MouseAdapter() {
      public void mouseReleased(MouseEvent e) {
        if (e.getButton() == 1 && e.getClickCount() == 1) {
        	invoke.deleteCorrelation( correlation);
          process.write();
        }
      }
    });
  }
}
