
package org.act.wsc.bpel4wsmodeling.view.graphic.leftbuttonproperty;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.DefaultCellEditor;
import javax.swing.JComboBox;
import org.act.wsc.bpel4wsmodeling.projectdata.process.Figure;
import org.act.wsc.bpel4wsmodeling.view.graphic.table.EachRowEditor;
import org.act.wsc.bpel4wsmodeling.view.graphic.table.EachRowRenderer;
import org.act.wsc.bpel4wsmodeling.view.resource.ResChoose;
import org.act.wsc.bpel4wsmodeling.def.process.Copy;
import org.act.wsc.bpel4wsmodeling.def.process.Correlation;
import org.act.wsc.bpel4wsmodeling.def.process.Pick;
import java.util.List;
import java.util.ResourceBundle;
import java.util.Vector;
import javax.swing.JTextField;
import java.awt.event.KeyListener;
import java.awt.event.KeyEvent;

public class PickProperty
    extends AbstractActProperty {
	 ResourceBundle res = ResChoose.getLanguage();
  Pick pickActivity;
  JComboBox combCreateInstance;
  String createInstance = null;
  String name = null;
  String joinCondition = null;
  String suppressJoinFailure = null;
  
  public PickProperty(Figure f) {
    super(f);
    this.pickActivity = (Pick)this.act;
    this.initAttTable();
  }
  
  void initAttTable() {
    name = this.act.getAtNameValue();
    joinCondition = this.act.getAtJoinConditionValue();
    suppressJoinFailure = this.act.getAtsuppressJoinFailureValue();
    createInstance = this.pickActivity.getAtCreateInstanceValue();
    defaultAttTableModel.setDataVector(new Object[][] { {"name", name}
                                       , {"joinCondition", joinCondition}
                                       , {"suppressJoinFailure",
                                       suppressJoinFailure}
                                       , {"createInstance", createInstance}
                                       , }
                                       , new Object[] {
    		res.getString("propertyname"),res.getString("propertyvalue")});
    txtname = new JTextField();
    txtname.addKeyListener(new KeyListener() {
      public void keyPressed(KeyEvent e) {
        if (e.getKeyCode() == KeyEvent.VK_ENTER) {
          act.setAtNameValue(txtname.getText());
          process.write();
        }
      }
      public void keyReleased(KeyEvent e) {
      }
      public void keyTyped(KeyEvent e) {
      }
    }
    );
    this.txtjoinCondition = new JTextField();
    txtjoinCondition.addKeyListener(new KeyListener() {
      public void keyPressed(KeyEvent e) {
        if (e.getKeyCode() == KeyEvent.VK_ENTER) {
          act.setAtJoinConditionValue(txtjoinCondition.getText());
          process.write();
        }
      }
      public void keyReleased(KeyEvent e) {
      }
      public void keyTyped(KeyEvent e) {
      }
    }
    );
    this.comBoxsuppressJoinFailure = new JComboBox();
    this.comBoxsuppressJoinFailure.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        if (e.getSource().equals(comBoxsuppressJoinFailure)) {
          act.setAtSuppressJoinFailureValue(comBoxsuppressJoinFailure.
                                            getSelectedItem().toString());
          process.write();
        }
      }
    });
    this.combCreateInstance = new JComboBox();
    this.combCreateInstance.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        if (e.getSource().equals(combCreateInstance)) {
          pickActivity.setAtCreateInstanceValue(combCreateInstance
                                                .getSelectedItem().toString());
          process.write();
        }
      }
    });
    
    EachRowRenderer rowRenderer = new EachRowRenderer();
    
    EachRowEditor rowEditor = new EachRowEditor(jAttTable);
    DefaultCellEditor txtnameEditor = new DefaultCellEditor(txtname);
    DefaultCellEditor txtJoinConditionEditor = new DefaultCellEditor(
        txtjoinCondition);
    DefaultCellEditor txtSuppressJoinFailureEditor = new DefaultCellEditor(
        comBoxsuppressJoinFailure);
    DefaultCellEditor comCreateInstanceEditor = new DefaultCellEditor(
        combCreateInstance);
    rowEditor.setEditorAt(0, txtnameEditor);
    rowEditor.setEditorAt(1, txtJoinConditionEditor);
    rowEditor.setEditorAt(2, txtSuppressJoinFailureEditor);
    rowEditor.setEditorAt(3, comCreateInstanceEditor);
    this.jAttTable.getColumn(res.getString("propertyvalue")).setCellRenderer(rowRenderer);
    this.jAttTable.getColumn(res.getString("propertyvalue")).setCellEditor(rowEditor);
  }
  
  public void addCopy(Copy c) {
  }
  
  public void deleteCopy(Copy c) {
  }
  
  public void setAttTable() {
    List it6 = new Vector();
    List it7 = new Vector();
    int j6 = this.comBoxsuppressJoinFailure.getActionListeners().length - 1;
    int j7 = this.combCreateInstance.getActionListeners().length - 1;
    for (int i = j6; i >= 0; i--) {
      ActionListener it = this.comBoxsuppressJoinFailure.getActionListeners()[i];
      it6.add(it);
      this.comBoxsuppressJoinFailure.removeActionListener(it);
    }
    for (int i = j7; i >= 0; i--) {
      ActionListener it = this.combCreateInstance.getActionListeners()[i];
      it7.add(it);
      this.combCreateInstance.removeActionListener(it);
    }
    comBoxsuppressJoinFailure.removeAllItems();
    this.combCreateInstance.removeAllItems();
    comBoxsuppressJoinFailure.addItem("yes");
    comBoxsuppressJoinFailure.addItem("no");
    this.combCreateInstance.addItem("yes");
    this.combCreateInstance.addItem("no");
    if (this.pickActivity != null) {
      this.txtname.setText(this.name);
      this.txtjoinCondition.setText(this.joinCondition);
      for (int f = 0; f < this.comBoxsuppressJoinFailure.getItemCount(); f++) {
        String txtcon = (String)this.comBoxsuppressJoinFailure.getItemAt(f);
        if (this.suppressJoinFailure  .equals(txtcon)) {
          this.comBoxsuppressJoinFailure.setSelectedIndex(f);
          break;
        }
      }
      if (this.createInstance != null && this.createInstance != "") {
        for (int g = 0; g < this.combCreateInstance.getItemCount(); g++) {
          String ins = (String)this.combCreateInstance.getItemAt(g);
          if (this.createInstance.equals(ins)) {
            this.combCreateInstance.setSelectedIndex(g);
            break;
          }
        }
      }
    }
    for (int i = 0; i < it6.size(); i++) {
      ActionListener it = (ActionListener) it6.get(i); ;
      this.comBoxsuppressJoinFailure.addActionListener(it);
    }
    for (int i = 0; i < it7.size(); i++) {
      ActionListener it = (ActionListener) it7.get(i); ;
      this.combCreateInstance.addActionListener(it);
    }
  }

public void addCorrelation(Correlation c) {
		
}

public void deleteCorrelation(Correlation correlation) {
		
}

public void correlatinNameUpdate(Correlation c, String s) {
        
}
}
