package org.act.wsc.bpel4wsmodeling.view.graphic.leftbuttonproperty;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.util.List;
import java.util.ResourceBundle;
import java.util.Vector;
import javax.swing.DefaultCellEditor;
import javax.swing.JComboBox;
import javax.swing.JTextField;
import org.act.wsc.bpel4wsmodeling.def.process.Copy;
import org.act.wsc.bpel4wsmodeling.def.process.Correlation;
import org.act.wsc.bpel4wsmodeling.def.process.Throw;
import org.act.wsc.bpel4wsmodeling.def.process.Variable;
import org.act.wsc.bpel4wsmodeling.projectdata.process.Figure;
import org.act.wsc.bpel4wsmodeling.view.graphic.table.EachRowEditor;
import org.act.wsc.bpel4wsmodeling.view.graphic.table.EachRowRenderer;
import org.act.wsc.bpel4wsmodeling.view.resource.ResChoose;
//<p></p><p></p><p></p><p></p>
public class ThrowProperty
    extends AbstractActProperty {
	ResourceBundle res = ResChoose.getLanguage();
  Throw throwActivity;
  JTextField txtFaultName;
  JComboBox comBoxFaultVariable;
  String name = null;
  String joinCondition = null;
  String suppressJoinFailure = null;
  String faultName = null;
  String faultVariable = null;
  public ThrowProperty(Figure f) {
    super(f);
    this.throwActivity = (Throw)this.act;
    initAttTable();
  }
  
  void initAttTable() {
        name = this.act.getAtNameValue();
    joinCondition = this.act.getAtJoinConditionValue();
    suppressJoinFailure = this.act.getAtsuppressJoinFailureValue();
    faultName = this.throwActivity.getAtFaultNameValue();
    faultVariable = this.throwActivity.getAtFaultVariableValue();
    defaultAttTableModel.setDataVector(
        new Object[][] { {"name", name}
        , {"joinCondition", joinCondition}
        , {"suppressJoinFailure", suppressJoinFailure}
        , {
        "faultName", faultName}
        , {
        "faultVariable", faultVariable}
    }
        ,
        new Object[] {
        		res.getString("propertyname"), res.getString("propertyvalue")});
    txtname = new JTextField();
    txtname.addKeyListener(new KeyListener() {
      public void keyPressed(KeyEvent e) {
        if (e.getKeyCode() == KeyEvent.VK_ENTER) {
          act.setAtNameValue(txtname.getText());
          process.write();
        }
      }
      public void keyReleased(KeyEvent e) {
      }
      public void keyTyped(KeyEvent e) {
      }
    }
    );
    this.txtjoinCondition = new JTextField();
    txtjoinCondition.addKeyListener(new KeyListener() {
      public void keyPressed(KeyEvent e) {
        if (e.getKeyCode() == KeyEvent.VK_ENTER) {
          act.setAtJoinConditionValue(txtjoinCondition.getText());
          process.write();
        }
      }
      public void keyReleased(KeyEvent e) {
      }
      public void keyTyped(KeyEvent e) {
      }
    }
    );
    this.comBoxsuppressJoinFailure = new JComboBox();
    this.comBoxsuppressJoinFailure.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        if (e.getSource().equals(comBoxsuppressJoinFailure)) {
          act.setAtSuppressJoinFailureValue(comBoxsuppressJoinFailure.
                                            getSelectedItem().toString());
          process.write();
        }
      }
    });
    this.txtFaultName = new JTextField();
    txtFaultName.addKeyListener(new KeyListener() {
      public void keyPressed(KeyEvent e) {
        if (e.getKeyCode() == KeyEvent.VK_ENTER) {
          act.setAtJoinConditionValue(txtjoinCondition.getText());
          process.write();
        }
      }
      public void keyReleased(KeyEvent e) {
      }
      public void keyTyped(KeyEvent e) {
      }
    }
    );
    this.comBoxFaultVariable = new JComboBox();
    this.comBoxFaultVariable.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        if (e.getSource().equals(comBoxFaultVariable)) {
          throwActivity.setAtFaultVariableValue(comBoxFaultVariable.
                                                getSelectedItem().toString());
          process.write();
        }
      }
    });
    
    EachRowRenderer rowRenderer = new EachRowRenderer();
    
    EachRowEditor rowEditor = new EachRowEditor(jAttTable);
    DefaultCellEditor txtnameEditor = new DefaultCellEditor(txtname);
    DefaultCellEditor txtJoinConditionEditor = new DefaultCellEditor(
        txtjoinCondition);
    DefaultCellEditor txtSuppressJoinFailureEditor = new DefaultCellEditor(
        comBoxsuppressJoinFailure);
    DefaultCellEditor txtFaultNameEditor = new DefaultCellEditor(
        txtFaultName);
    DefaultCellEditor comBoxFaultVariableEditor = new DefaultCellEditor(
        comBoxFaultVariable);
    rowEditor.setEditorAt(0, txtnameEditor);
    rowEditor.setEditorAt(1, txtJoinConditionEditor);
    rowEditor.setEditorAt(2, txtSuppressJoinFailureEditor);
    rowEditor.setEditorAt(3, txtFaultNameEditor);
    rowEditor.setEditorAt(4, comBoxFaultVariableEditor);
    this.jAttTable.getColumn(res.getString("propertyvalue")).setCellRenderer(rowRenderer);
    this.jAttTable.getColumn(res.getString("propertyvalue")).setCellEditor(rowEditor);
  }
  
  public void addCopy(Copy c) {
  }
  
  public void deleteCopy(Copy c) {
  }
  
  public void setAttTable() {
    List it6 = new Vector();
    List it7 = new Vector();
    int j6 = this.comBoxsuppressJoinFailure.getActionListeners().length - 1;
    int j7 = this.comBoxFaultVariable.getActionListeners().length - 1;
    for (int i = j6; i >= 0; i--) {
      ActionListener it = this.comBoxsuppressJoinFailure.getActionListeners()[i];
      it6.add(it);
      this.comBoxsuppressJoinFailure.removeActionListener(it);
    }
    for (int i = j7; i >= 0; i--) {
      ActionListener it = this.comBoxFaultVariable.getActionListeners()[i];
      it7.add(it);
      this.comBoxFaultVariable.removeActionListener(it);
    }
    comBoxsuppressJoinFailure.removeAllItems();
    this.comBoxFaultVariable.removeAllItems();
    comBoxsuppressJoinFailure.addItem("yes");
    comBoxsuppressJoinFailure.addItem("no");
    List tempvs=figure.getVariableList();
      for (int i = 0; i < tempvs.size(); i++) {
        Variable v = (Variable) tempvs.get(i);
        String variablename = v.getAtNameValue();
        this.comBoxFaultVariable.addItem(variablename);
      }
    if (this.throwActivity != null) {
      this.txtname.setText(this.name);
      this.txtjoinCondition.setText(this.joinCondition);
      for (int f = 0; f < this.comBoxsuppressJoinFailure.getItemCount(); f++) {
        String txtcon = (String)this.comBoxsuppressJoinFailure.getItemAt(f);
        if (this.suppressJoinFailure.equals(txtcon)) {
          this.comBoxsuppressJoinFailure.setSelectedIndex(f);
          break;
        }
      }
      this.txtFaultName.setText(this.faultName);
      for (int f = 0; f < this.comBoxFaultVariable.getItemCount(); f++) {
        String txtcon = (String)this.comBoxFaultVariable.getItemAt(f);
        if (this.faultVariable.equals(txtcon)) {
          this.comBoxFaultVariable.setSelectedIndex(f);
          break;
        }
      }
    }
    for (int i = 0; i < it6.size(); i++) {
      ActionListener it = (ActionListener) it6.get(i); ;
      this.comBoxsuppressJoinFailure.addActionListener(it);
    }
    for (int i = 0; i < it7.size(); i++) {
      ActionListener it = (ActionListener) it7.get(i); ;
      this.comBoxFaultVariable.addActionListener(it);
    }
  }

public void addCorrelation(Correlation c) {
		
}

public void deleteCorrelation(Correlation correlation) {
		
}

public void correlatinNameUpdate(Correlation c, String s) {
        
}
}
