
package org.act.wsc.bpel4wsmodeling.view.graphic.rightbuttonmenu;
import java.util.ResourceBundle;
import javax.swing.JMenuItem;
import javax.swing.JPopupMenu;
import org.act.wsc.bpel4wsmodeling.projectdata.process.Figure;
import org.act.wsc.bpel4wsmodeling.view.action.DelFigureAction;
import org.act.wsc.bpel4wsmodeling.view.resource.ResChoose;

public abstract class AbstractRightMenu extends JPopupMenu {
	 
	 ResourceBundle res = ResChoose.getLanguage();
	JMenuItem delItem=new JMenuItem(res.getString("delete"));
	Figure figure;
	
	protected AbstractRightMenu(Figure figure) {
		super();
		this.figure = figure;
		this.add(delItem);
		this.addSeparator();
		delItem.addActionListener(new DelFigureAction(figure));
	}
}
