
package org.act.wsc.bpel4wsmodeling.view.graphic.rightbuttonmenu;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ResourceBundle;
import javax.swing.JMenuItem;
import javax.swing.JOptionPane;
import org.act.wsc.bpel4wsmodeling.debug.engine.WSWF;
import org.act.wsc.bpel4wsmodeling.def.process.Activity;
import org.act.wsc.bpel4wsmodeling.projectdata.process.Figure;
import org.act.wsc.bpel4wsmodeling.projectdata.process.FlowFigure;
import org.act.wsc.bpel4wsmodeling.view.gui.MainFrame;
import org.act.wsc.bpel4wsmodeling.view.resource.ResChoose;

public class FlowRightMenu extends AbstractRightMenu {
	 
	 ResourceBundle res = ResChoose.getLanguage();
	private JMenuItem addBranchItem=new JMenuItem(res.getString("addActivity"));
	
	public FlowRightMenu(Figure f) {
		super(f);
		this.add(this.addBranchItem);
		this.addBranchItem.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
			    String debugId=null;
			    if (figure.getOwner().isInDebug()&&figure.getServicesSet() instanceof Activity) {
                    Activity activity = (Activity) figure.getServicesSet();
                    debugId=activity.getAtDebugIdValue();
                                        if(!WSWF.inStack(debugId)){
                        JOptionPane.showMessageDialog(MainFrame.getmainFrame(),res.getString("cannotAddremoveactivity"),res.getString("warning"),JOptionPane.ERROR_MESSAGE);;
                        return;
                    }
                }
				((FlowFigure)FlowRightMenu.this.figure).addFigure(null);
				if(figure.getOwner().isInDebug()){
				    WSWF.replace(figure.getServicesSet(),debugId);
				}
			}
		});
	}
}
