
package org.act.wsc.bpel4wsmodeling.view.gui;
import java.awt.BorderLayout;
import java.awt.Color;
import java.util.Iterator;
import java.util.List;
import java.util.Vector;
import javax.swing.JPanel;
import javax.swing.JTree;
import javax.swing.SwingUtilities;
import javax.swing.tree.DefaultMutableTreeNode;
import org.act.metaset.Metaset;
import org.act.wsc.bpel4wsmodeling.debug.engine.WSWF;

public class DataPanel extends JPanel{
    JTree tree;
    DefaultMutableTreeNode root=new DefaultMutableTreeNode();
    List variables=new Vector();
    
    public DataPanel() {
        super();
        jbInit();
    }
    
    private void jbInit() {
        tree=new JTree(root);
        tree.setBackground(Color.WHITE);
        this.setLayout(new BorderLayout());
        this.add(tree);
    }
    public void clearAll(){
        root.removeAllChildren();
        SwingUtilities.invokeLater(new Runnable() {
            public void run() {
                tree.updateUI();
            }
        });
    }
    public void updateVariables(){
                root.removeAllChildren();
                Metaset variables=WSWF.getVars();
                        for (Iterator iter = variables.getChilds().iterator(); iter.hasNext();) {
            Metaset variable = (Metaset) iter.next();
            String vName=variable.selector(".\\","name");
            DefaultMutableTreeNode vNode=new DefaultMutableTreeNode(vName);
            root.add(vNode);
            for (Iterator iterator = variable.getChilds().iterator(); iterator.hasNext();) {
                Metaset part = (Metaset) iterator.next();
                String pName=part.selector(".\\","name");
                String pValue=part.getValue();
                vNode.add(new DefaultMutableTreeNode(pName+" = "+"\""+pValue+"\""));
            }
        }
        SwingUtilities.invokeLater(new Runnable() {
            public void run() {
                tree.updateUI();
            }
        });
        
    }
}
