package org.act.wsc.bpel4wsmodeling.view.gui;
import javax.swing.*;
import javax.swing.tree.*;
//<p></p><p></p><p></p><p></p>
public class IconNode extends DefaultMutableTreeNode  {
  protected Icon   icon,openIcon,closedIcon;
  protected String iconName,openIconName,closedIconName;
  public IconNode() {
    this(null);
  }
  public IconNode(Object userObject) {
    this(userObject, true, null);
  }
  public IconNode(Object userObject, boolean allowsChildren
                       , Icon icon) {
    super(userObject, allowsChildren);
    this.icon = icon;
  }
  public void setIcon(Icon icon) {
    this.icon = icon;
  }
  public Icon getIcon() {
    return icon;
  }
  public void setOpenIcon(Icon openIcon) {
    this.openIcon = openIcon;
  }
  public Icon getOpenIcon() {
    return openIcon;
  }
  public void setClosedIcon(Icon closedIcon) {
  this.closedIcon = closedIcon;
  }
  public Icon getClosedIcon() {
    return closedIcon;
  }
  public String getIconName() {
    if (iconName != null) {
      return iconName;
    } else {
      String str = userObject.toString();
      int index = str.lastIndexOf(".");
      if (index != -1) {
        return str.substring(++index);
      } else {
        return null;
      }
    }
  }
 public void setIconName(String name) {
    iconName = name;
  }
  public String getOpenIconName() {
    if (openIconName != null) {
      return openIconName;
    } else {
      String str = userObject.toString();
      int index = str.lastIndexOf(".");
      if (index != -1) {
        return str.substring(++index);
      } else {
        return null;
      }
    }
  }
  public void setOpenIconName(String name) {
     openIconName = name;
  }
  public String getClosedIconName() {
    if (closedIconName != null) {
      return closedIconName;
    } else {
      String str = userObject.toString();
      int index = str.lastIndexOf(".");
      if (index != -1) {
        return str.substring(++index);
      } else {
        return null;
      }
    }
  }
  public void setClosedIconName(String name) {
     closedIconName = name;
  }
}
