package org.act.wsc.bpel4wsmodeling.view.processassist;
import java.awt.*;
import javax.swing.*;
import java.awt.event.*;
import javax.swing.border.Border;
import javax.swing.event.*;
import java.util.*;
import java.lang.Exception;
import org.uddi4j.*;
import org.uddi4j.client.UDDIProxy;
import org.uddi4j.response.ServiceInfo;
import org.uddi4j.response.BusinessList;
import org.uddi4j.response.BusinessInfo;
import org.uddi4j.response.ServiceDetail;
import org.uddi4j.datatype.Name;
import org.uddi4j.datatype.service.BusinessService;
import org.uddi4j.datatype.binding.BindingTemplate;
import org.uddi4j.datatype.binding.TModelInstanceInfo;
import org.uddi4j.response.TModelDetail;
import org.uddi4j.datatype.tmodel.TModel;
import org.uddi4j.response.TModelList;
import org.uddi4j.response.TModelInfo;
import org.uddi4j.util.TModelBag;
import org.uddi4j.util.TModelKey;
import org.uddi4j.response.ServiceList;
import javax.wsdl.WSDLException;
import javax.wsdl.factory.*;
import javax.wsdl.xml.*;
import javax.wsdl.*;
import javax.wsdl.extensions.*;
import com.ibm.wsdl.xml.*;
import com.ibm.wsdl.factory.WSDLFactoryImpl;
import com.ibm.wsdl.extensions.*;
import org.act.wsc.bpel4wsmodeling.view.gui.MainFrame;
import org.act.wsc.bpel4wsmodeling.view.resource.ResChoose;
//<p></p><p></p><p></p><p></p>
public class NewPartner
    extends JDialog {
    Container contentPane;   JPanel firstPanel, secondPanel, thirdPanel, fourPanel,fifthPanel;    String UDDIServerURL;       JButton nextButton,cancelButton, finishButton;   JButton preButton;  Border padding;   JTextField UDDIServer;   UDDIProxy proxy = new UDDIProxy();
  Vector tModelNameVector = new Vector();   Vector tModelKeyVector = new Vector();   Vector tModelInfoVector = new Vector();   Vector serviceInfoVector = new Vector();
  Vector allBusinessVector=new Vector();  Vector allServiceVector = new Vector();   Vector allInstanceVector = new Vector();   TModelInfo tModelInfo = null;
  JList UDDIresult, serviceResult, instanceResult;   ServiceInfo service;
  BusinessInfo business;  int keyIndex = -1;   int index = -1;   String spTypeURL;   String instanceOverviewURL;     
  
  
  ResourceBundle res = ResChoose.getLanguage();
  public NewPartner(MainFrame frame, String title,
                    boolean b ) {
    super(frame, title, b);
        contentPane = this.getContentPane();
        contentPane.setLayout(new GridLayout(1, 1));
    firstPanel = createFirstBox();
            padding = BorderFactory.createEmptyBorder(15, 15, 5, 15);
    firstPanel.setBorder(padding);
    contentPane.add(firstPanel, BorderLayout.CENTER);
  }
  
  public NewPartner(String title, boolean b) {
    super(MainFrame.getmainFrame(), title, b);
        contentPane = this.getContentPane();
        contentPane.setLayout(new GridLayout(1, 1));
    firstPanel = createFirstBox();
            padding = BorderFactory.createEmptyBorder(15, 15, 5, 15);
    firstPanel.setBorder(padding);
    contentPane.add(firstPanel, BorderLayout.CENTER);
  }
  
  private JPanel createFirstBox() {
            JComboBox UDDIServerComboBox;
    JLabel label = new JLabel(res.getString("uddiServer"));
    UDDIServer = new JTextField(50);
                                     UDDIServer.setText("http://192.168.2.111:9000/uddi/servlet/uddirouter");
        nextButton = new JButton(res.getString("nextStep"));
    nextButton.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        UDDIServerURL = (String) UDDIServer.getText();
        secondPanel = createSecondBox(UDDIServerURL);
        if (secondPanel != null) {
          contentPane.add(secondPanel);
          pack();
          setSize(400, 400);
          show();
        }
      }
    });
    cancelButton = new JButton(res.getString("no"));
    cancelButton.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        dispose();
      }
    });
        JPanel mainPanel = new JPanel();     JPanel buttonPanel = new JPanel();     mainPanel.setLayout(new GridLayout(3, 1, 0, 10));
    mainPanel.add(label);
    mainPanel.add(UDDIServer);
    buttonPanel.setLayout(new FlowLayout());
    buttonPanel.add(nextButton);
    buttonPanel.add(cancelButton);
    mainPanel.add(buttonPanel);
    return mainPanel;
  }
  
  private JPanel createSecondBox(String UDDIServer) {     JPanel buttonPanel = new JPanel();
    JLabel label = new JLabel("     "+res.getString("tModelList"));
    
     contentPane.removeAll() ;        try {
      proxy.setInquiryURL(UDDIServer);       proxy.setPublishURL(UDDIServer);
            String tModelName = new String("%");       TModelList tModelList = proxy.find_tModel(tModelName, null, null, null, 0);
      tModelInfoVector = tModelList.getTModelInfos().getTModelInfoVector();                   if (tModelInfoVector.size() < 1) {
        JOptionPane.showConfirmDialog(null, res.getString("nofound"), res.getString("warning"),
                                      JOptionPane.CANCEL_OPTION,
                                      JOptionPane.OK_CANCEL_OPTION);
        spTypeURL = null;
        instanceOverviewURL = null;
        return null;
              }
            for (int i = 0; i < tModelInfoVector.size(); i++) {
        tModelInfo = (TModelInfo) tModelInfoVector.elementAt(i);
        tModelNameVector.add( (Object) (new String(tModelInfo.getNameString())));
        tModelKeyVector.add( (Object) (new String(tModelInfo.getTModelKey())));
      }     }
    catch (Exception ex) {
      JOptionPane.showConfirmDialog(null, res.getString("cannotconnect"), res.getString("warning"),
                                    JOptionPane.CANCEL_OPTION,
                                    JOptionPane.OK_CANCEL_OPTION);
      spTypeURL = null;
      instanceOverviewURL = null;
      dispose();
      return null;
    }
        UDDIresult = new JList(tModelNameVector);
    JScrollPane scrollPane = new JScrollPane(UDDIresult);
    UDDIresult.setVisibleRowCount(5);
    
    
    UDDIresult.addListSelectionListener(new javax.swing.event.
                                        ListSelectionListener() {
      public void valueChanged(ListSelectionEvent e) {
        try {
          JList source = (JList) e.getSource();
          keyIndex = source.getSelectedIndex();           UDDIresult.setToolTipText(res.getString("servicetypeyouchoose")+((TModelInfo)tModelInfoVector.elementAt(keyIndex)).getNameString() ) ;          if (keyIndex < 0) {
            JOptionPane.showConfirmDialog(null, res.getString("choosefirst"), res.getString("warning"),
                                          JOptionPane.CANCEL_OPTION,
                                          JOptionPane.OK_CANCEL_OPTION);
          }
          else {
                        String tModelKey = (String) tModelKeyVector.elementAt(keyIndex);
            TModelDetail tModelDetail = proxy.get_tModelDetail(tModelKey);
            TModel tModel = (TModel) tModelDetail.getTModelVector().elementAt(0);
                                                            spTypeURL = (tModel.getOverviewDoc()).getOverviewURLString();
                  
                      }
        }
        catch (Exception ex) {
          System.out.println(res.getString("errorgettmodel") + ex.toString());
          spTypeURL = null;
          instanceOverviewURL = null;
        }
      }
    });
        nextButton = new JButton(res.getString("defineservicelocationtype"));
    nextButton.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        if (UDDIresult.getSelectedIndex() < 0) {
          JOptionPane.showConfirmDialog(null, res.getString("choosebusinesstypeYouneed"), res.getString("warning"),
                                        JOptionPane.CANCEL_OPTION,
                                        JOptionPane.OK_CANCEL_OPTION);
        }
        else {
                    thirdPanel = createThirdBox(keyIndex);
          if (thirdPanel != null) {
            contentPane.add(thirdPanel);
            show();
          }
        }
      }
    });
        preButton=new JButton(" "+res.getString("back"));
    preButton.addActionListener(new ActionListener(){
      public void actionPerformed(ActionEvent e){
                              tModelInfoVector.removeAllElements() ;
        tModelNameVector.removeAllElements() ;
        tModelKeyVector.removeAllElements() ;
                firstPanel=createFirstBox();
        if(firstPanel!=null)
          contentPane.removeAll()  ;
          contentPane.add(firstPanel) ;
          setSize(400,180);
          show();
      }
    });
        
    cancelButton = new JButton(res.getString("no"));
    cancelButton.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        dispose();
      }
    });
        JPanel secondPanel = new JPanel();
    secondPanel.setLayout(new BorderLayout());
    secondPanel.setBorder(padding);
    secondPanel.add(label, "North");
    JPanel centerPanel = new JPanel();
    centerPanel.setLayout(new BorderLayout());
    centerPanel.add(new JLabel("    "), "North");
    centerPanel.add(new JLabel("       "), "West");
    centerPanel.add(new JLabel("       "), "East");
    centerPanel.add(new JLabel("  "), "South");
    centerPanel.add(scrollPane, "Center");
    secondPanel.add(centerPanel, "Center");
    buttonPanel.setLayout(new FlowLayout());
    buttonPanel.add(preButton);
    buttonPanel.add(nextButton);
        buttonPanel.add(cancelButton);
    secondPanel.add(buttonPanel, "South");
    return secondPanel;
  }
  
  private JPanel createThirdBox(int keyIndex) {    JPanel buttonPanel = new JPanel();
    JLabel label = new JLabel("     "+res.getString("businessServices"));
    
    contentPane.removeAll() ;    tModelInfo = (TModelInfo) tModelInfoVector.elementAt(keyIndex);
    String strtModelKey = tModelInfo.getTModelKey();
        TModelBag tModelBag = new TModelBag();
    if (!strtModelKey.equals("")) {
            Vector vecTModelKey = new Vector();
      vecTModelKey.addElement(new TModelKey(strtModelKey));
      tModelBag.setTModelKeyVector(vecTModelKey);
    }
    try {
            BusinessList businessList = null;
      businessList = proxy.find_business(null, null, null, null, tModelBag, null,
                                         0);
      Vector businessInfoVector = businessList.getBusinessInfos().
          getBusinessInfoVector();
                  if (businessInfoVector.size() < 1) {
        JOptionPane.showConfirmDialog(null, res.getString("nofound"), res.getString("warning"),
                                      JOptionPane.CANCEL_OPTION,
                                      JOptionPane.OK_CANCEL_OPTION);
        spTypeURL = null;
        instanceOverviewURL = null;
        dispose();
        return null;
      }                  for(int i=0;i<businessInfoVector.size();i++)
      {
        business=(BusinessInfo)businessInfoVector.elementAt(i) ;
        allBusinessVector.add(business) ;
      }
            ServiceList serviceList = proxy.find_service("", null, null, tModelBag, null,
          0);
            serviceInfoVector = serviceList.getServiceInfos().getServiceInfoVector();
            
      for (int j = 0; j < serviceInfoVector.size(); j++) {
        service = (ServiceInfo) serviceInfoVector.elementAt(j);
                                               allServiceVector.addElement(service);
              }
    }
    catch (Exception ex) {
      spTypeURL = null;
      instanceOverviewURL = null;
      System.out.println(ex);
      return null;
    }
        String[] serviceArray = new String[allServiceVector.size()];
    for (int i = 0; i < allServiceVector.size(); i++) {
      serviceArray[i] = ( (ServiceInfo) allServiceVector.elementAt(i)).
          getNameString();     }
    serviceResult = new JList(serviceArray);
    JScrollPane scrollPane = new JScrollPane(serviceResult);
    serviceResult.addListSelectionListener(new javax.swing.event.
                                           ListSelectionListener() {
      public void valueChanged(ListSelectionEvent e) {
        JList source = (JList) e.getSource();
        index = source.getSelectedIndex();
        service = (ServiceInfo) allServiceVector.elementAt(index);
                      for(int num=0;num<allBusinessVector.size();num++)
        {
          business=(BusinessInfo)allBusinessVector.elementAt(num);
          if(service.getBusinessKey().equals(business.getBusinessKey() ) ){
            serviceResult.setToolTipText(res.getString("whatyouchoose")+business.getNameString() +res.getString("provided")+service.getNameString() +res.getString("service")) ;
          }
        }
                              }
    });
            nextButton = new JButton(res.getString("nextStep"));
    nextButton.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        if (serviceResult.getSelectedIndex() < 0) {
          JOptionPane.showConfirmDialog(null, res.getString("needRelatedwithoneWSDL"),
                                        res.getString("warning"), JOptionPane.CANCEL_OPTION,
                                        JOptionPane.OK_CANCEL_OPTION);
        }
        else {
          JPanel fourthPanel = createFourthBox(service);
          if (fourthPanel != null) {
            contentPane.add(fourthPanel);
            show();
          }
        }
      }
    });
            preButton=new JButton(res.getString("back"));
    preButton.addActionListener(new ActionListener(){
    public void actionPerformed(ActionEvent e){
              serviceInfoVector.removeAllElements() ;
        allServiceVector.removeAllElements() ;
                      tModelNameVector.removeAllElements() ;
               tModelKeyVector.removeAllElements() ;
                tModelInfoVector.removeAllElements() ;
                    JPanel secondPanel=createSecondBox(UDDIServerURL);
            contentPane.add(secondPanel) ;
      show();
    }
  }) ;
      cancelButton = new JButton(res.getString("no"));
    cancelButton.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
                dispose();
      }
    });
        JPanel thirdPanel = new JPanel();
    thirdPanel.setLayout(new BorderLayout());
    thirdPanel.setBorder(padding);
    thirdPanel.add(label, "North");
    JPanel centerPanel = new JPanel();
        centerPanel.setLayout(new BorderLayout());
    centerPanel.add(new JLabel(" "), "North");
    centerPanel.add(new JLabel("       "), "West");
    centerPanel.add(new JLabel("       "), "East");
    centerPanel.add(new JLabel("  "), "South");
    centerPanel.add(scrollPane, "Center");
    thirdPanel.add(centerPanel, "Center");
        buttonPanel.setLayout(new FlowLayout());
    buttonPanel.add(preButton) ;    buttonPanel.add(nextButton);
    buttonPanel.add(cancelButton);
    thirdPanel.add(buttonPanel, "South");
    return thirdPanel;
  }
    
  private JPanel createFourthBox(ServiceInfo si) {
    index = -1;
    JPanel buttonPanel = new JPanel();
    JLabel label = new JLabel("     "+res.getString("businessServiceWSDLURL"));
      contentPane.removeAll() ;    try {
      String serviceName = si.getNameString();
      ServiceDetail serviceDetail = proxy.get_serviceDetail(si.getServiceKey());
      Vector bSVector = serviceDetail.getBusinessServiceVector();
      BusinessService bs = (BusinessService) bSVector.elementAt(0);
      Vector bindingTVector = bs.getBindingTemplates().getBindingTemplateVector();
      String[] accessPointStr =  new String[bindingTVector.size()];
      for (int i = 0; i < bindingTVector.size(); i++) {
                BindingTemplate bt = (BindingTemplate) bindingTVector.elementAt(i);
                                
                                                        accessPointStr[i] = bt.getAccessPoint().getText();
        System.out.println();
                instanceOverviewURL = accessPointStr[i] + "?wsdl";
                        allInstanceVector.addElement( (Object) instanceOverviewURL);
                                      }     }
    catch (Exception e) {
          }
                            String[] instanceArray = new String[allInstanceVector.size()];
    for (int i = 0; i < allInstanceVector.size(); i++) {
      instanceArray[i] = (String)allInstanceVector.elementAt(i);     }
    instanceResult = new JList(instanceArray);
    JScrollPane scrollPane = new JScrollPane(instanceResult);
    instanceResult.setToolTipText(res.getString("whatyouneed")+service.getNameString() +res.getString("businessServiceWSDLURLaddress")+instanceOverviewURL) ;    instanceResult.addListSelectionListener(new javax.swing.event.
                                           ListSelectionListener() {
      public void valueChanged(ListSelectionEvent e) {
        JList source = (JList) e.getSource();
        index = source.getSelectedIndex();
        instanceOverviewURL = (String) allInstanceVector.elementAt(index);
      }
    });
           nextButton = new JButton(res.getString("importWSDLfile"));
    nextButton.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        if (instanceResult.getSelectedIndex() < 0) {
          JOptionPane.showConfirmDialog(null, res.getString("pleasechoosebusinessService"), res.getString("warning"),
                                        JOptionPane.CANCEL_OPTION,
                                        JOptionPane.OK_CANCEL_OPTION);
        }
        else {
                    JPanel fifthPanel = createFifthBox();
          if (fifthPanel != null) {
            contentPane.add(fifthPanel);
            setSize(400,200);
            show();
          }
          else{          }
                 }
      }
    });
        preButton=new JButton(res.getString("back"));
    preButton.addActionListener(new ActionListener(){
    public void actionPerformed(ActionEvent e){
             allInstanceVector.removeAllElements() ;
            serviceInfoVector.removeAllElements() ;
      allServiceVector.removeAllElements() ;      JPanel thirdPanel=createThirdBox(keyIndex);
       contentPane.add(thirdPanel) ;
       show();
    }}) ;
        cancelButton = new JButton(res.getString("no"));
    cancelButton.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
                  instanceOverviewURL=null;      dispose();      }
    });
        JPanel fourthPanel = new JPanel();
    fourthPanel.setLayout(new BorderLayout());
    fourthPanel.setBorder(padding);
    fourthPanel.add(label, "North");
    JPanel centerPanel = new JPanel();
        centerPanel.setLayout(new BorderLayout());
    centerPanel.add(new JLabel(" "), "North");
    centerPanel.add(new JLabel("       "), "West");
    centerPanel.add(new JLabel("       "), "East");
    centerPanel.add(new JLabel("  "), "South");
    centerPanel.add(scrollPane, "Center");
    fourthPanel.add(centerPanel, "Center");
        buttonPanel.setLayout(new FlowLayout());
    buttonPanel.add(preButton) ;    buttonPanel.add(nextButton);
    buttonPanel.add(cancelButton);
    fourthPanel.add(buttonPanel, "South");
    return fourthPanel;
  }
        private JPanel createFifthBox(){
      JPanel fifthPanel=new JPanel();
      contentPane.removeAll() ;
                  String s="";
      for(int num=0;num<allBusinessVector.size();num++)
      {
        business = (BusinessInfo) allBusinessVector.elementAt(num);
        if (service.getBusinessKey().equals(business.getBusinessKey())) {
           s=res.getString("businessEntity")+business.getNameString();
                   }
      }
            String allInformation=res.getString("youhavechoosed")+tModelInfo.getNameString().toString()  +res.getString("tModel")+"\n"+res.getString("choosedservicename")+service.getNameString() +"\n"+s+"\n"+res.getString("thisbusinessServiceWSDLURL")+instanceOverviewURL+"\n";
      JTextArea allInfo=new JTextArea(allInformation);
            nextButton=new JButton(res.getString("yes"));
      nextButton.addActionListener(new ActionListener() {
        public void actionPerformed(ActionEvent e) {
                        dispose();
        }
      });
      cancelButton=new JButton(res.getString("no"));
      cancelButton.addActionListener(new ActionListener() {
        public void actionPerformed(ActionEvent e) {
                    instanceOverviewURL = null;           dispose();         }
      });
            fifthPanel.setLayout(new BorderLayout()) ;
      fifthPanel.setBorder(padding) ;
      fifthPanel.add(new Label(""),"North");
      JPanel centerPanel=new JPanel();
      centerPanel.add(new JScrollPane(allInfo)) ;
      fifthPanel.add(centerPanel, "Center");
      JPanel buttonPanel = new JPanel();
      buttonPanel.setLayout(new FlowLayout());
      buttonPanel.add(nextButton);
      buttonPanel.add(cancelButton);
      fifthPanel.add(buttonPanel, "South");
      fifthPanel.setOpaque(false);      return fifthPanel;
    }
    
  public String getSPTypeURL() {
    return spTypeURL;
  }
  
  public String getInstanceURL() {
    return instanceOverviewURL;
  }
  }
