package org.act.wsc.bpel4wsmodeling.def.process;
import java.util.Iterator;
import java.util.List;
import java.util.Vector;
import org.act.metaset.Attribute;
import org.act.metaset.Metaset;
import org.act.wsc.bpel4wsmodeling.bpeldata.listener.INoActivityChildListener;
import org.act.wsc.bpel4wsmodeling.utils.CreateDebugId;
//<p></p><p></p><p></p><p></p>
public class OnMessage extends Metaset {
    Attribute partnerLink;
    Attribute portType;
    Attribute operation;
    Attribute variable;
        Attribute debugId;
    Activity act;
    protected List childListeners = new Vector();
   
    public OnMessage() {
        super("onMessage");
        this.partnerLink = new Attribute("partnerLink", "");
        this.portType = new Attribute("portType", "");
        this.operation = new Attribute("operation", "");
        this.variable = new Attribute("variable", "");
                this.debugId = new Attribute("debugId", CreateDebugId.getDebugId());
                this.add(this.debugId);
        this.add(this.partnerLink);
        this.add(this.portType);
        this.add(this.operation);
        this.add(this.variable);
    }
    public void setAtPartnerLinkValue(String s) {
        this.partnerLink.setValue(s);
    }
    public String getAtPartnerLinkValue() {
        return this.partnerLink.getValue();
    }
    public void setAtPortTypeValue(String s) {
        this.portType.setValue(s);
    }
    public String getAtPortTypeValue() {
        return this.portType.getValue();
    }
    public void setAtOperationValue(String s) {
        this.operation.setValue(s);
    }
    public String getAtOperationValue() {
        return this.operation.getValue();
    }
    public void setAtVariableValue(String s) {
        this.variable.setValue(s);
    }
    public String getAtVariableValue() {
        return this.variable.getValue();
    }
        public void setAtDebugIdValue(String s) {
        this.debugId.setValue(s);
    }
        public String getAtDebugIdValue() {
        return this.debugId.getValue();
    }
    public void addActivity(Activity activity) {
        if ((this.filter(".\\invoke") == null)
                && (this.filter(".\\receive") == null)
                && (this.filter(".\\reply") == null)
                && (this.filter(".\\assign") == null)
                && (this.filter(".\\wait") == null)
                && (this.filter(".\\throw") == null)
                && (this.filter(".\\scope") == null)
                && (this.filter(".\\sequence") == null)
                && (this.filter(".\\while") == null)
                && (this.filter(".\\switch") == null)
                && (this.filter(".\\flow") == null)
                && (this.filter(".\\pick") == null)
                && (this.filter(".\\empty") == null)
                && (this.filter(".\\compensate") == null)
                && (this.filter(".\\terminate") == null)) {
            this.add(activity);
            activity.setFather(this);
            this.act = activity;
        }
    }
    public void deleteActivity(Activity activity) {
        this.remove(activity);
    }
    public void deleteActivity() {
        if (this.act != null) {
            this.remove(act);
        }
    }
                public Activity getActivity() {
        if (this.filter(".\\invoke") != null) {
            return (Invoke) this.filter(".\\invoke").car();
        }
        if (this.filter(".\\receive") != null) {
            return (Receive) this.filter(".\\receive").car();
        }
        if (this.filter(".\\reply") != null) {
            return (Reply) this.filter(".\\reply").car();
        }
        if (this.filter(".\\assign") != null) {
            return (Assign) this.filter(".\\assign").car();
        }
        if (this.filter(".\\wait") != null) {
            return (Wait) this.filter(".\\wait").car();
        }
        if (this.filter(".\\throw") != null) {
            return (Throw) this.filter(".\\throw").car();
        }
        if (this.filter(".\\scope") != null) {
            return (Scope) this.filter(".\\scope").car();
        }
        if (this.filter(".\\sequence") != null) {
            return (Sequence) this.filter(".\\sequence").car();
        }
        if (this.filter(".\\while") != null) {
            return (While) this.filter(".\\while").car();
        }
        if (this.filter(".\\switch") != null) {
            return (Switch) this.filter(".\\switch").car();
        }
        if (this.filter(".\\flow") != null) {
            return (Flow) this.filter(".\\flow").car();
        }
        if (this.filter(".\\pick") != null) {
            return (Pick) this.filter(".\\pick").car();
        }
        if (this.filter(".\\empty") != null) {
            return (Empty) this.filter(".\\empty").car();
        }
        if (this.filter(".\\compensate") != null) {
            return (Compensate) this.filter(".\\compensate").car();
        }
        if (this.filter(".\\terminate") != null) {
            return (Terminate) this.filter(".\\terminate").car();
        }
        return null;
    }
    public void addCorrelations(Correlations correlations) {
        if (this.filter(".\\correlations") == null) {
            this.add(correlations);
            correlations.setFather(this);
        }
    }
    public Metaset getCorrelations() {
        return this.filter(".\\correlations");
    }
    public void detelteCorrelations(Correlations correlations) {
        this.remove(correlations);
    }
    
    public void addCorrelation(Correlation correlation) {
        Correlations correlations;
        if (this.filter(".\\correlations") == null) {
            correlations = new Correlations();
            this.add(correlations);
            correlations.setFather(this);
        } else {
            correlations = (Correlations) this.getCorrelations().car();
        }
        if (correlations.addCorrelation(correlation) == true) {
            fireCorrelationAdded(correlation);
        }
    }
    
    public void deleteCorrelation(Correlation correlation) {
        fireCorrelationDeleted(correlation);
        Correlations correlations = (Correlations) this.getCorrelations().car();
        correlations.deleteCorrelation(correlation);
        if (correlations.getChilds().size() == 0) {
            this.detelteCorrelations(correlations);
        }
    }
    
    private void fireCorrelationAdded(Correlation correlation) {
                for (Iterator iter = this.childListeners.iterator(); iter.hasNext();) {
            INoActivityChildListener element = (INoActivityChildListener) iter
                    .next();
            element.addCorrelation(correlation);
        }
    }
    
    private void fireCorrelationDeleted(Correlation correlation) {
                for (Iterator iter = this.childListeners.iterator(); iter.hasNext();) {
            INoActivityChildListener element = (INoActivityChildListener) iter
                    .next();
            element.deleteCorrelation(correlation);
        }
    }
    
    public void addChildListeners(INoActivityChildListener l) {
        if (!this.childListeners.contains(l)) {
            this.childListeners.add(l);
        }
    }
    public void deleteChildListeners(INoActivityChildListener l) {
        if (!this.childListeners.contains(l)) {
            this.childListeners.remove(l);
        }
    }
  
}
