
package org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define;
import java.util.List;
import java.util.Vector;

public class MIMEPart extends ExtensibilityElementEx {
    String name=null;
    List extensibilityElements=new Vector();
    
    public MIMEPart() {
        super();
            }
    
    public String getName() {
        if(this.name==null){
            this.name=this.getLabelName();
        }
        return this.name;
    }
    
    public void setName(String name) {
        this.name = name;
        this.firePropertyChanged(this);
    }
    
    public void reName(String newName){
        if(newName==null){
            return;
        }
        String oldName=this.getName();
        if(!newName.equals(oldName)){
            this.setName(newName);
            this.fireChildRenamed(this);
        }
    }
    
    public void addExtensibilityElementEx(ExtensibilityElementEx extensibilityElementEx){
        this.extensibilityElements.add(extensibilityElementEx);
        this.fireChildAdded(extensibilityElementEx);
    }
    public void removeExtensibilityElementEx(ExtensibilityElementEx extensibilityElementEx){
        this.extensibilityElements.remove(extensibilityElementEx);
        this.fireChildRemoved(extensibilityElementEx);
    }
    
    
   
    
    public List getExtensibilityElements() {
        return extensibilityElements;
    }
}
