
package org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import javax.wsdl.Fault;
import javax.wsdl.Input;
import javax.wsdl.Operation;
import javax.wsdl.OperationType;
import javax.wsdl.Output;
import javax.xml.namespace.QName;
import org.w3c.dom.Element;

public class OperationEx extends WSDLLabel implements IDerivedLabel,Operation {
    public static int timer=0;
    Operation operation=null;
    
    private String name=null;
    private Map faults=new HashMap();
    private InputEx inputEx=null;
    private OutputEx outputEx=null;
    public static final String ATT_NAME = "name";
    
    
    public OperationEx(Operation operation) {
        super();
        this.operation = operation;
    }
    
    public OperationEx() {
        super();
            }
    
    public boolean addChild(WSDLLabel childLabel) {
        return false;
    }
    
    public boolean removeChild(WSDLLabel childLabel) {
        if(childLabel instanceof FaultEx){
            this.removeFault((Fault) childLabel);
            return true;
        }
        if(childLabel instanceof InputEx){
            this.removeInput((InputEx) childLabel);
                return true;
        }
        if(childLabel instanceof OutputEx){
            this.removeOutput((OutputEx) childLabel);
        }
        return false;
    }
   
    
    public Operation getOperation() {
        return operation;
    }
    
    
    public void addFault(Fault fault) {
        if (fault instanceof FaultEx) {
            FaultEx faultEx = (FaultEx) fault;
            this.faults.put(faultEx.getName(),faultEx);
            faultEx.setOperationEx(this);
            this.fireChildAdded(faultEx);
        }
    }
    public void removeFault(Fault fault) {
        
        if (fault instanceof FaultEx) {
            FaultEx new_name = (FaultEx) fault;
            this.faults.remove(new_name.getName());
            this.fireChildRemoved(new_name);
        }
    }
    
    public Element getDocumentationElement() {
                return null;
    }
    
    public Fault getFault(String faultName) {
        
        return (FaultEx) this.faults.get(faultName);
    }
    
    public Map getFaults() {
        
        return this.faults;
    }
    
    public Input getInput() {
       
        return this.inputEx;
    }
    
    public Output getOutput() {
       
        return this.outputEx;
    }
    
    public List getParameterOrdering() {
                return null;
    }
    
    public OperationType getStyle() {
                return null;
    }
    
    public boolean isUndefined() {
                return false;
    }
    
    public void setDocumentationElement(Element arg0) {
                
    }
    
    public void setInput(Input input) {
        if(input!=null&&input instanceof InputEx){
            this.inputEx=(InputEx) input;
        }else{
            this.inputEx=null;
        }  
    }
    public void addInput(InputEx inputEx){
        if(this.inputEx==null){
            this.setInput(inputEx);   
            this.fireChildAdded(inputEx);
        }
        
    }
    public void removeInput(InputEx inputEx){
        if(this.inputEx!=null&&this.inputEx.equals(inputEx)){
            this.setInput(null);  
            this.fireChildRemoved(inputEx);
        }
        
    }
    
    public void setOutput(Output output) {
        if(output!=null&&output instanceof OutputEx){
            this.outputEx=(OutputEx) output;
        }else{
            this.outputEx=null;
        }  
    }
    public void addOutput(OutputEx outputEx){
        if(this.outputEx==null){
            this.setOutput(outputEx);  
            this.fireChildAdded(outputEx);
        }
        
    }
    public void removeOutput(OutputEx outputEx){
        if(this.outputEx!=null&&this.outputEx.equals(outputEx)){
            this.setOutput(null);    
            this.fireChildRemoved(outputEx);
        }
        
    }
    
    public void setParameterOrdering(List arg0) {
                
    }
    
    public void setStyle(OperationType arg0) {
                
    }
    
    public void setUndefined(boolean arg0) {
                
    }
    
    public String getName() {
        if(this.name==null){
            this.name=this.getLabelName();
        }
        return this.name;
    }
    
    public void setName(String name) {
        this.name=name;
    }
    public void reName(String newName){
        if(newName==null){
            return;
        }
        String oldName=this.getName();
        
        if(!newName.equals(oldName)){
            this.setName(newName);
            this.fireChildRenamed(this);
            this.firePropertyChanged(this);
        }
    }
    
    public Object getExtensionAttribute(QName arg0) {
                return null;
    }
    
    public Map getExtensionAttributes() {
                return null;
    }
    
    public List getNativeAttributeNames() {
                return null;
    }
    
    public void setExtensionAttribute(QName arg0, Object arg1) {
                
    }
}
