
package org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define;

public class SOAPBody extends ExtensibilityElementEx {
    private String parts=null;
    private String use=null;
    private String encodingStyle=null;
    private String namespace=null;
    public static final String ATT_PARTS = "parts";
    public static final String ATT_USE = "use";
    public static final String ATT_ENC_STYLE = "encodingStyle";
    public static final String ATT_NS = "namespace";
    
    public SOAPBody() {
        super();
            }
    
    public String getName() {
        
        return this.getLabelName();
    }
    
    public String getEncodingStyle() {
        return encodingStyle;
    }
    
    public void setEncodingStyle(String encodingStyle) {
        String oldProperty=this.encodingStyle;
        if(oldProperty==null||!oldProperty.equals(encodingStyle)){
            this.encodingStyle = encodingStyle;
            this.firePropertyChanged(this);
        }
    }
    
    public String getParts() {
        return parts;
    }
    
    
    public void setParts(String parts) {
        String oldProperty=this.parts;
        if(oldProperty==null||!oldProperty.equals(parts)){
            this.parts = parts;
            this.firePropertyChanged(this);
        }
    }
    
    public String getUse() {
        return use;
    }
    
    public void setUse(String use) {
        String oldProperty=this.use;
        if(oldProperty==null||!oldProperty.equals(use)){
            this.use = use;
            this.firePropertyChanged(this);
        }
    }
    
    public String getNamespace() {
        return namespace;
    }
    
    public void setNamespace(String namespace) {
        String oldProperty=this.namespace;
        if(oldProperty==null||!oldProperty.equals(namespace)){
            this.namespace = namespace;
            this.firePropertyChanged(this);
        }
    }
}
