
package org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define;

public class SOAPFault extends ExtensibilityElementEx {
    private String name=null;
    private String use=null;
    private String encodingStyle=null;
    private String namespace=null;
    public static final String ATT_NAME = "name";
    public static final String ATT_USE = "use";
    public static final String ATT_ENC_STYLE = "encodingStyle";
    public static final String ATT_NS = "namespace";
    
    public SOAPFault() {
        super();
       
    }
    
    public String getName() {
        if(this.name==null){
            this.name=this.getLabelName();
        }
        return this.name;
    }
    
    public String getEncodingStyle() {
        return encodingStyle;
    }
    
    public void setEncodingStyle(String encodingStyle) {
        this.encodingStyle = encodingStyle;
    }
    
    public String getNamespace() {
        return namespace;
    }
    
    public void setNamespace(String namespace) {
        String oldProperty=this.namespace;
        if(oldProperty==null||!oldProperty.equals(namespace)){
            this.namespace = namespace;
            this.firePropertyChanged(this);
        }
    }
    
    public String getUse() {
        return use;
    }
    
    public void setUse(String use) {
        this.use = use;
    }
    
    public void setName(String name) {
        String oldProperty=this.name;
        if(oldProperty==null||!oldProperty.equals(name)){
            this.name = name;
            this.firePropertyChanged(this);
        }
    }
    public void reName(String newName){
        if(newName==null){
            return;
        }
        String oldName=this.getName();
        if(!newName.equals(oldName)){
            this.setName(newName);
            this.fireChildRenamed(this);
        }
    }
}
