
package org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.view.popmenu;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ResourceBundle;
import javax.swing.JMenuItem;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.BindingEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.DefinitionEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.WSDLLabel;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.view.MyTreeNode;
import org.act.wsc.bpel4wsmodeling.view.resource.ResChoose;

public class BindingsRightMenu extends AbstractTreeRightMenu {
	
	  private ResourceBundle res = ResChoose.getLanguage();
	
	 JMenuItem addItem=new JMenuItem(res.getString("BIRM_ABinding"));
	    
	    
	    public BindingsRightMenu(MyTreeNode myTreeNode) {
	        super(myTreeNode);
	        
	        this.add(this.addItem);
	        this.addItem.addActionListener(new ActionListener(){
	            public void actionPerformed(ActionEvent e) {
	                WSDLLabel label=((MyTreeNode)BindingsRightMenu.this.myTreeNode.getParent()).getWsdlLabel();
	                if(label instanceof DefinitionEx){
	                    DefinitionEx definitionEx=(DefinitionEx)label;                 
	                    BindingEx bindingEx= (BindingEx) definitionEx.createBinding();
	                    definitionEx.addBinding(bindingEx);
	                } 
	            }            
	        });
	        
	    }
	
	
}
	
	
	
	
	
    
                       
             
   