
package org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.view.popmenu;
import java.awt.BorderLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ResourceBundle;
import javax.swing.JMenu;
import javax.swing.JMenuItem;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.JRadioButtonMenuItem;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.ComplexTypeEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.WSDLLabel;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.view.MyTreeNode;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.view.propertyeditor.PropertyEditorFactory;
import org.act.wsc.bpel4wsmodeling.view.resource.ResChoose;

public class ComplexTypeRightMenu extends AbstractTreeRightMenu {
	
	  private ResourceBundle res = ResChoose.getLanguage();
    JPanel contentPane = new JPanel();
    BorderLayout borderLayout1 = new BorderLayout();
    JMenuItem setName = new JMenuItem(res.getString("CTRM_SetName"));
    JMenu addCombiner = new JMenu(res.getString("CTRM_AAssembly"));
    JRadioButtonMenuItem jRadioButtonMenuItem1 = new JRadioButtonMenuItem("all");
    JRadioButtonMenuItem jRadioButtonMenuItem2 = new JRadioButtonMenuItem(
            "sequence");
    JRadioButtonMenuItem jRadioButtonMenuItem3 = new JRadioButtonMenuItem(
            "choice");
    JRadioButton jRadioButton1 = new JRadioButton();
    private void jbInit() throws Exception {
        addCombiner.add(jRadioButtonMenuItem1);
        addCombiner.add(jRadioButtonMenuItem2);
        addCombiner.add(jRadioButtonMenuItem3);
                contentPane.setLayout(borderLayout1);
        contentPane.add(jRadioButton1, BorderLayout.NORTH);
    }
    
    public ComplexTypeRightMenu(MyTreeNode myTreeNode) {
        super(myTreeNode);
        if (ComplexTypeRightMenu.this.myTreeNode.getWsdlLabel() instanceof ComplexTypeEx) {
            final ComplexTypeEx complexTypeEx = (ComplexTypeEx) ComplexTypeRightMenu.this.myTreeNode
                    .getWsdlLabel();
            this.setName.addActionListener(new ActionListener() {
                public void actionPerformed(ActionEvent e) {
                    String initialV = complexTypeEx.getName();
                    String result = PropertyEditorFactory.showEditor(
                            ComplexTypeEx.ATT_NAME + ": ", res.getString("CTRM_Set") + ComplexTypeEx.ATT_NAME,
                            initialV);
                    if(result!=null){
                        complexTypeEx.setName(result);
                    }
                   
                }
            });
            this.add(this.setName);
            this.add(this.addCombiner);
            this.jRadioButtonMenuItem1.addActionListener(new ActionListener() {
                public void actionPerformed(ActionEvent e) {
                    WSDLLabel label = ComplexTypeRightMenu.this.myTreeNode
                            .getWsdlLabel();
                    if (label instanceof ComplexTypeEx) {
                        ComplexTypeEx complexTypeEx = (ComplexTypeEx) label;
                        complexTypeEx.addCombiner("all");
                    }
                }
            });
            this.jRadioButtonMenuItem2.addActionListener(new ActionListener() {
                public void actionPerformed(ActionEvent e) {
                    WSDLLabel label = ComplexTypeRightMenu.this.myTreeNode
                            .getWsdlLabel();
                    if (label instanceof ComplexTypeEx) {
                        ComplexTypeEx complexTypeEx = (ComplexTypeEx) label;
                        complexTypeEx.addCombiner("sequence");
                    }
                }
            });
            this.jRadioButtonMenuItem3.addActionListener(new ActionListener() {
                public void actionPerformed(ActionEvent e) {
                    WSDLLabel label = ComplexTypeRightMenu.this.myTreeNode
                            .getWsdlLabel();
                    if (label instanceof ComplexTypeEx) {
                                                ComplexTypeEx complexTypeEx = (ComplexTypeEx) label;
                        complexTypeEx.addCombiner("choice");
                    }
                }
            });
        }
                                                                                                
                this.add(this.removeItem);
        try {
            jbInit();
        } catch (Exception e1) {
                        e1.printStackTrace();
        }
    }
}
