
package org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.view.popmenu;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Iterator;
import java.util.List;
import java.util.ResourceBundle;
import java.util.Vector;
import javax.swing.JMenuItem;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.FaultEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.MessageEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.view.MyTreeNode;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.view.propertyeditor.PropertyEditorFactory;
import org.act.wsc.bpel4wsmodeling.view.resource.ResChoose;

public class FaultRightMenu extends AbstractTreeRightMenu {
	
	private ResourceBundle res = ResChoose.getLanguage();
    JMenuItem setName=new JMenuItem(res.getString("FARM_SetName"));
   JMenuItem setMessage=new JMenuItem(res.getString("FARM_SetMessage=message"));
  
    
    public FaultRightMenu(MyTreeNode myTreeNode) {
        super(myTreeNode);
        if (FaultRightMenu.this.myTreeNode.getWsdlLabel() instanceof FaultEx) {
            final FaultEx faultEx = (FaultEx) FaultRightMenu.this.myTreeNode
                    .getWsdlLabel();
            this.setName.addActionListener(new ActionListener(){
                public void actionPerformed(ActionEvent e) {
                    String initialV=faultEx.getName();
                    String result=PropertyEditorFactory.showEditor(FaultEx.ATT_NAME+": ",res.getString("FARM_Set")+FaultEx.ATT_NAME,initialV);
                    if(result!=null){
                        faultEx.setName(result);
                    }
                }});
            this.add(setName);
            this.setMessage.addActionListener(new ActionListener() {
                public void actionPerformed(ActionEvent e) {
                    List options = new Vector();
                    for (Iterator iter = faultEx.getDefinitionEx()
                            .getMessages().values().iterator(); iter.hasNext();) {
                        MessageEx element = (MessageEx) iter.next();
                        options.add(faultEx.getDefinitionEx().QNameToString(element.getQName()));
                    }
                    String initialV = null;
                    if (faultEx.getMessage() != null) {
                        initialV = faultEx.getDefinitionEx().QNameToString(faultEx.getMessage()
                                .getQName());
                    }
                    String message = PropertyEditorFactory.showEditor( FaultEx.ATT_MESSAGE + ": ", res.getString("FARM_Set")
                            + FaultEx.ATT_MESSAGE, initialV, options);
                    if(message!=null){
                        faultEx.setMessage(faultEx.getDefinitionEx().getMessage(faultEx.getDefinitionEx().StringToQName(message)));    
                    }
                    
                }
            });
            this.add(setMessage);
         }
        this.add(this.removeItem);
    }
}
