
package org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.view.popmenu;
import java.util.ResourceBundle;
import javax.swing.JMenuItem;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.HTTPBinding;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.view.MyTreeNode;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.view.propertyeditor.PropertyEditorFactory;
import org.act.wsc.bpel4wsmodeling.view.resource.ResChoose;

public class HTTPBindingRightMenu extends AbstractTreeRightMenu {
	
	  private ResourceBundle res = ResChoose.getLanguage();
   JMenuItem setVerb=new JMenuItem(res.getString("HTTPBIRM_SetVerb"));
  
    
    public HTTPBindingRightMenu(MyTreeNode myTreeNode) {
        super(myTreeNode);
        if (myTreeNode.getWsdlLabel() instanceof HTTPBinding) {
            HTTPBinding binding = (HTTPBinding) myTreeNode.getWsdlLabel();
            String initialV=binding.getVerb();
            String result=PropertyEditorFactory.showEditor(HTTPBinding.ATT_VERB+": ",res.getString("HTTPBIRM_Set")+HTTPBinding.ATT_VERB,initialV);
            if (result!=null) {
                binding.setVerb(result);    
            }
            
        }
        this.add(setVerb);
       
        
               this.add(this.removeItem);
    }
}
