
package org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.view.popmenu;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ResourceBundle;
import javax.swing.JMenuItem;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.ImportEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.view.MyTreeNode;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.view.propertyeditor.PropertyEditorFactory;
import org.act.wsc.bpel4wsmodeling.view.resource.ResChoose;

public class ImportRightMenu extends AbstractTreeRightMenu {
	
	private ResourceBundle res = ResChoose.getLanguage();
   JMenuItem setNameSpace=new JMenuItem(res.getString("IMPRM_SetNamespace"));
   JMenuItem setLocation=new JMenuItem(res.getString("IMPRM_SetLocation"));
    
    public ImportRightMenu(MyTreeNode myTreeNode) {
        super(myTreeNode);
        if (ImportRightMenu.this.myTreeNode.getWsdlLabel() instanceof ImportEx) {
            final ImportEx importEx = (ImportEx) ImportRightMenu.this.myTreeNode.getWsdlLabel();
           
            this.setNameSpace.addActionListener(new ActionListener(){
                public void actionPerformed(ActionEvent e) {
                    String ns=PropertyEditorFactory.showEditor(ImportEx.ATT_NS+": ",res.getString("IMPRM_Set")+ImportEx.ATT_NS,importEx.getNamespaceURI());
                    if (ns!=null) {
                        importEx.setNamespaceURI(ns);    
                    }
                    
                }});
            this.add(setNameSpace);
            
            this.setLocation.addActionListener(new ActionListener(){
                public void actionPerformed(ActionEvent e) {
                    String loc=PropertyEditorFactory.showEditor(ImportEx.ATT_LOC_URL+": ",res.getString("IMPRM_Set")+ImportEx.ATT_LOC_URL,importEx.getLocationURI());
                    if (loc!=null) {
                       importEx.setLocationURI(loc); 
                    }
                    
                    
                }});
            this.add(setLocation);
        }
        this.add(this.removeItem);
    }
}
