
package org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.view.popmenu;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Iterator;
import java.util.List;
import java.util.ResourceBundle;
import java.util.Vector;
import javax.swing.JMenuItem;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.BindingInputEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.BindingOutputEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.InputEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.MIMEContent;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.OutputEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.PartEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.WSDLLabel;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.view.MyTreeNode;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.view.propertyeditor.PropertyEditorFactory;
import org.act.wsc.bpel4wsmodeling.view.resource.ResChoose;

public class MIMEContentRightMenu extends AbstractTreeRightMenu {
	
	private ResourceBundle res = ResChoose.getLanguage();
   JMenuItem setPart=new JMenuItem(res.getString("MIMECRM_SetPart"));
   JMenuItem setType=new JMenuItem(res.getString("MIMECRM_SetType"));
  
    
    public MIMEContentRightMenu(MyTreeNode myTreeNode) {
        super(myTreeNode);
        if (myTreeNode.getWsdlLabel() instanceof MIMEContent) {
            final MIMEContent content = (MIMEContent) myTreeNode.getWsdlLabel();
            
            MyTreeNode node=myTreeNode;
            do{
                node=((MyTreeNode)node.getParent());
            }while(!(node.getWsdlLabel() instanceof InputEx)||node.getWsdlLabel() instanceof OutputEx);
            final WSDLLabel ownerLabel=node.getWsdlLabel();
            this.setPart.addActionListener(new ActionListener(){
                public void actionPerformed(ActionEvent e) {
                    String initialV=content.getPart();
                    List options=new Vector();
                    if(ownerLabel instanceof BindingInputEx){
                        BindingInputEx bindingInputEx=(BindingInputEx)ownerLabel;
                        for (Iterator iter = bindingInputEx.getInputEx().getMessage().getParts().values().iterator(); iter.hasNext();) {
                            PartEx element = (PartEx) iter.next();
                            options.add(element.getName());
                        }
                    }
                    else if(ownerLabel instanceof BindingOutputEx){
                        BindingOutputEx bindingOutputEx=(BindingOutputEx)ownerLabel;
                        for (Iterator iter = bindingOutputEx.getOutputEx().getMessage().getParts().values().iterator(); iter.hasNext();) {
                            PartEx element = (PartEx) iter.next();
                            options.add(element.getName());
                        }
                    }
                    String result=PropertyEditorFactory.showEditor(MIMEContent.ATT_PART+": ",res.getString("MIMECRM_Set")+MIMEContent.ATT_PART,initialV,options);
                    if (result!=null) {
                        content.setPart(result);
                    }
                    
                }});
            this.add(setPart);
            
            this.setType.addActionListener(new ActionListener(){
                public void actionPerformed(ActionEvent e) {
                    String initialV=content.getType();
                    String result=PropertyEditorFactory.showEditor(MIMEContent.ATT_TYPE+": ",""+MIMEContent.ATT_TYPE,initialV);
                    if (result!=null) {
                        content.setType(result);
                    }
                }});
            this.add(setType);
           
        }
       
                  }
}
