
package org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.view.popmenu;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ResourceBundle;
import javax.swing.JMenuItem;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.DefinitionEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.MessageEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.WSDLLabel;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.view.MyTreeNode;
import org.act.wsc.bpel4wsmodeling.view.resource.ResChoose;

public class MessagesRightMenu extends AbstractTreeRightMenu {
	
	private ResourceBundle res = ResChoose.getLanguage();
    private JMenuItem addItem=new JMenuItem(res.getString("MERM_AMessage"));
    
    public MessagesRightMenu(MyTreeNode myTreeNode) {
        super(myTreeNode);
        this.add(this.addItem);
        this.addItem.addActionListener(new ActionListener(){
            public void actionPerformed(ActionEvent e) {
                WSDLLabel label=((MyTreeNode) MessagesRightMenu.this.myTreeNode.getParent()).getWsdlLabel();
                if(label instanceof DefinitionEx){
                    DefinitionEx definitionEx=(DefinitionEx)label;  
                    definitionEx.addMessage((MessageEx) definitionEx.createMessage());
                    
                } 
            }            
        });
    }
}
