
package org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.view.popmenu;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ResourceBundle;
import javax.swing.JMenuItem;
import javax.swing.JOptionPane;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.OperationEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.PortTypeEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.WSDLLabel;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.view.MyTreeNode;
import org.act.wsc.bpel4wsmodeling.view.gui.MainFrame;
import org.act.wsc.bpel4wsmodeling.view.resource.ResChoose;

public class PortTypeRightMenu extends AbstractTreeRightMenu {
	
	private ResourceBundle res = ResChoose.getLanguage();
    JMenuItem addOperation=new JMenuItem(res.getString("PTRM_AOperation"));
    
    public PortTypeRightMenu(MyTreeNode myTreeNode) {
        super(myTreeNode);
        this.renameItem.addActionListener(new ActionListener(){
            public void actionPerformed(ActionEvent e) {
                String newName=JOptionPane.showInputDialog(MainFrame.getmainFrame(),res.getString("PTRM_NewName"),res.getString("PTRM_Rename"),JOptionPane.QUESTION_MESSAGE);
                if (PortTypeRightMenu.this.myTreeNode.getWsdlLabel() instanceof PortTypeEx) {
                	PortTypeEx portTypeEx = (PortTypeEx) PortTypeRightMenu.this.myTreeNode.getWsdlLabel();
                	portTypeEx.reName(newName);
                }
            }});
        this.add(this.addOperation);
        this.addOperation.addActionListener(new ActionListener(){
            public void actionPerformed(ActionEvent e) {
                WSDLLabel label=PortTypeRightMenu.this.myTreeNode.getWsdlLabel();
                if (label instanceof PortTypeEx) {
                	PortTypeEx portTypeEx = (PortTypeEx) label;
                    OperationEx operationEx=(OperationEx)portTypeEx.getDefinitionEx().createOperation();
                    portTypeEx.addOperation(operationEx);
                }
            }});
        
        this.add(this.renameItem);
        this.add(this.removeItem);
    }
}
