
package org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.view.popmenu;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Iterator;
import java.util.List;
import java.util.ResourceBundle;
import java.util.Vector;
import javax.swing.JMenuItem;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.ElementEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.SOAPHeader;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.SchemaEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.view.MyTreeNode;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.view.propertyeditor.PropertyEditorFactory;
import org.act.wsc.bpel4wsmodeling.view.resource.ResChoose;

public class SOAPHeaderRightMenu extends AbstractTreeRightMenu {
	private ResourceBundle res = ResChoose.getLanguage();
   JMenuItem setElement=new JMenuItem(res.getString("SOAPHRM_SetElement"));
   JMenuItem setFault=new JMenuItem(res.getString("SOAPHRM_SetFault"));
   
   
    public SOAPHeaderRightMenu(MyTreeNode myTreeNode) {
        super(myTreeNode);
        if (myTreeNode.getWsdlLabel() instanceof SOAPHeader) {
            final SOAPHeader header = (SOAPHeader) myTreeNode.getWsdlLabel();
            
            this.setElement.addActionListener(new ActionListener(){
                public void actionPerformed(ActionEvent e) {
                    String initialV=header.getElement();
                    List options=new Vector();
                    for (Iterator iter = header.getDefinitionEx().getTypes().getExtensibilityElements().iterator(); iter.hasNext();) {
                        SchemaEx schemaEx = (SchemaEx) iter.next();
                        for (Iterator iterator = schemaEx.getElememts().iterator(); iterator
                                .hasNext();) {
                            ElementEx element = (ElementEx) iterator.next();
                            if(element.getName()!=null&&element.getName()!=""){
                                options.add(element.getName()); 
                            }
                        }
                    }
                    String result=PropertyEditorFactory.showEditor(SOAPHeader.ATT_ELE+": ",res.getString("SOAPHRM_Set")+SOAPHeader.ATT_ELE,initialV,options);
                    if(result!=null){
                        header.setElement(result);
                    }
                }});
            this.add(setElement);
                        this.add(setFault);
        }
        
        
               this.add(this.removeItem);
    }
}
