package org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.view.
        propertyeditor;
import java.awt.Rectangle;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;
import java.util.ResourceBundle;
import javax.swing.DefaultListModel;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JTextField;
import javax.swing.SwingConstants;
import javax.xml.namespace.QName;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.DefinitionEx;
import org.act.wsc.bpel4wsmodeling.view.resource.ResChoose;
//<p></p><p></p><p></p><p></p>
public class DefinitionPropertyEditor extends APropertyEditor {
	 static ResourceBundle res = ResChoose.getLanguage();
    DefinitionEx definitionEx;
    JLabel jLabelTName = new JLabel();
    JTextField jTextFieldTN = new JTextField();
    JLabel jLabelName = new JLabel();
    JTextField jTextFieldName = new JTextField();
    JLabel jLabelNamespace = new JLabel();
    JLabel jLabelPrefix = new JLabel();
    JLabel jLabelValue = new JLabel();
    JTextField jTextFieldValue = new JTextField();
    JTextField jTextFieldPrefix = new JTextField();
    JList jListNs = new JList();
    JButton jButtonRemove = new JButton();
    JButton jButtonAdd = new JButton();
    JButton jButtonCancel = new JButton();
    JButton jButtonOk = new JButton();
    JLabel jLabelBindingType = new JLabel();
    JComboBox jComboBoxBindingType = new JComboBox();
    private Map namespaces=new HashMap();
    
    private boolean isCancel=false;
    public DefinitionPropertyEditor(DefinitionEx definitionEx) {
        super(res.getString("initializeDefinitions"));
        this.definitionEx=definitionEx;
        this.namespaces.putAll(this.definitionEx.getNamespaces());
        this.setSize(400,350);
        try {
           jbInit();
       } catch (Exception ex) {
           ex.printStackTrace();
       }
    }
    private void jbInit() throws Exception {
        this.getContentPane().setLayout(null);
        jLabelTName.setText("TargetNamespace");
        jLabelTName.setBounds(new Rectangle(16, 83, 104, 21));
        jTextFieldTN.setText(this.definitionEx.getTargetNamespace());
        jTextFieldTN.setBounds(new Rectangle(118, 82, 144, 22));
        jLabelName.setText("Name");
        jLabelName.setBounds(new Rectangle(19, 29, 42, 21));
        jTextFieldName.setText(this.definitionEx.getQName().getLocalPart());
        jTextFieldName.setBounds(new Rectangle(62, 28, 120, 21));
        jLabelPrefix.setHorizontalAlignment(SwingConstants.RIGHT);
        jLabelPrefix.setText("Prefix");
        jLabelPrefix.setBounds(new Rectangle(6, 184, 41, 21));
        jLabelValue.setHorizontalAlignment(SwingConstants.RIGHT);
        jLabelValue.setText("URI ");
        jLabelValue.setBounds(new Rectangle(10, 211, 41, 24));
        jTextFieldValue.setText("");
        jTextFieldValue.setBounds(new Rectangle(51, 211, 106, 24));
        jTextFieldPrefix.setText("");
        jTextFieldPrefix.setBounds(new Rectangle(51, 182, 107, 24));
        jListNs.setBounds(new Rectangle(232, 146, 154, 128));
        jListNs.setModel(new DefaultListModel());
        for (Iterator iter = this.definitionEx.getNamespaces().keySet().iterator(); iter.hasNext();) {
            String prefix = (String) iter.next();
            String uri=(String)this.definitionEx.getNamespace(prefix);
            ((DefaultListModel)jListNs.getModel()).addElement(prefix+"="+uri);
        }
        jButtonRemove.setBounds(new Rectangle(175, 213, 47, 25));
        jButtonRemove.setText("<<");
        jButtonRemove.addActionListener(new
                DefinitionPropertyEditor_jButtonRemove_actionAdapter(this));
        jButtonAdd.setBounds(new Rectangle(175, 182, 47, 25));
        jButtonAdd.setText(">>");
        jButtonAdd.addActionListener(new
                DefinitionPropertyEditor_jButtonAdd_actionAdapter(this));
        jButtonCancel.setBounds(new Rectangle(221, 285, 61, 25));
        jButtonCancel.setText(res.getString("no"));
        jButtonCancel.addActionListener(new
                DefinitionPropertyEditor_jButtonCancel_actionAdapter(this));
        jButtonOk.setBounds(new Rectangle(103, 286, 64, 25));
        jButtonOk.setText(res.getString("yes"));
        jButtonOk.addActionListener(new
                DefinitionPropertyEditor_jButtonOk_actionAdapter(this));
        jLabelNamespace.setText("NamespaceText");
        jLabelNamespace.setBounds(new Rectangle(41, 135, 73, 20));
        jLabelBindingType.setText("BindingType");
        jLabelBindingType.setBounds(new Rectangle(211, 27, 68, 24));
        jComboBoxBindingType.setBounds(new Rectangle(277, 27, 101, 24));
        jComboBoxBindingType.setSelectedItem("soap");
        jComboBoxBindingType.addItem("soap");
        jComboBoxBindingType.addItem("http");
        jComboBoxBindingType.addItem("mime");        this.getContentPane().add(jButtonCancel);
        this.getContentPane().add(jButtonOk);
        this.getContentPane().add(jTextFieldName);
        this.getContentPane().add(jLabelName);
        this.getContentPane().add(jTextFieldTN);
        this.getContentPane().add(jLabelTName);
        this.getContentPane().add(jListNs);
        this.getContentPane().add(jLabelNamespace);
        this.getContentPane().add(jLabelPrefix);
        this.getContentPane().add(jLabelValue);
        this.getContentPane().add(jTextFieldPrefix);
        this.getContentPane().add(jTextFieldValue);
        this.getContentPane().add(jButtonRemove);
        this.getContentPane().add(jButtonAdd);
        this.getContentPane().add(jLabelBindingType);
        this.getContentPane().add(jComboBoxBindingType);
    }
    public void jButtonAdd_actionPerformed(ActionEvent e) {
        String prefix=this.jTextFieldPrefix.getText();
        String uri=this.jTextFieldValue.getText();
        if(prefix!=""&&uri!=""){
            this.namespaces.put(this.jTextFieldPrefix.getText(),this.jTextFieldValue.getText());
            ((DefaultListModel)this.jListNs.getModel()).addElement(prefix+"="+uri);
            this.jTextFieldPrefix.setText("");
            this.jTextFieldValue.setText("");
        }
    }
    public void jButtonRemove_actionPerformed(ActionEvent e) {
        int selIndex=this.jListNs.getSelectedIndex();
        if(selIndex!=-1){
            String selItem=(String) ((DefaultListModel)this.jListNs.getModel()).remove(selIndex);
            String prefix=selItem.substring(0,selItem.indexOf('='));
            String value=(String) this.namespaces.remove(prefix);
            this.jTextFieldPrefix.setText(prefix);
            this.jTextFieldValue.setText(value);
        }
    }
    public void jButtonOk_actionPerformed(ActionEvent e) {
        if(this.jTextFieldName.getText()!=""){
            this.definitionEx.setQName(new QName(this.jTextFieldName.getText()));
        }
        if(this.jTextFieldTN.getText()!=""){
            this.definitionEx.setTargetNamespace(this.jTextFieldTN.getText());
        }
        this.definitionEx.getNamespaces().clear();
        this.definitionEx.getNamespaces().putAll(this.namespaces);
        this.definitionEx.setBindingType((String) this.jComboBoxBindingType.getSelectedItem());
        this.dispose();
        this.isCancel=false;
    }
    public void jButtonCancel_actionPerformed(ActionEvent e) {
        this.dispose();
        this.isCancel=true;
    }
    
    public boolean isCancel() {
        return isCancel;
    }
}
class DefinitionPropertyEditor_jButtonCancel_actionAdapter implements
        ActionListener {
    private DefinitionPropertyEditor adaptee;
    DefinitionPropertyEditor_jButtonCancel_actionAdapter(
            DefinitionPropertyEditor adaptee) {
        this.adaptee = adaptee;
    }
    public void actionPerformed(ActionEvent e) {
        adaptee.jButtonCancel_actionPerformed(e);
    }
}
class DefinitionPropertyEditor_jButtonOk_actionAdapter implements
        ActionListener {
    private DefinitionPropertyEditor adaptee;
    DefinitionPropertyEditor_jButtonOk_actionAdapter(DefinitionPropertyEditor
            adaptee) {
        this.adaptee = adaptee;
    }
    public void actionPerformed(ActionEvent e) {
        adaptee.jButtonOk_actionPerformed(e);
    }
}
class DefinitionPropertyEditor_jButtonRemove_actionAdapter implements
        ActionListener {
    private DefinitionPropertyEditor adaptee;
    DefinitionPropertyEditor_jButtonRemove_actionAdapter(
            DefinitionPropertyEditor adaptee) {
        this.adaptee = adaptee;
    }
    public void actionPerformed(ActionEvent e) {
        adaptee.jButtonRemove_actionPerformed(e);
    }
}
class DefinitionPropertyEditor_jButtonAdd_actionAdapter implements
        ActionListener {
    private DefinitionPropertyEditor adaptee;
    DefinitionPropertyEditor_jButtonAdd_actionAdapter(DefinitionPropertyEditor
            adaptee) {
        this.adaptee = adaptee;
    }
    public void actionPerformed(ActionEvent e) {
        adaptee.jButtonAdd_actionPerformed(e);
    }
}
