package org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.view.
        propertyeditor;
import java.awt.*;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.ComplexTypeEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.ElementEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.SchemaEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.SimpleTypeEx;
import org.act.wsc.bpel4wsmodeling.utils.ConstanceSet;
import org.act.wsc.bpel4wsmodeling.view.resource.ResChoose;
import javax.swing.ButtonGroup;
import javax.swing.JRadioButton;
import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JButton;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Iterator;
import java.util.ResourceBundle;
//<p></p><p></p><p></p><p></p>
public class ElementProperty extends APropertyEditor {
	 static ResourceBundle res = ResChoose.getLanguage();
    ElementEx element;
    JRadioButton jRadioButtonCT = new JRadioButton();
    JRadioButton jRadioButtonAddT = new JRadioButton();
    JRadioButton jRadioButtonST = new JRadioButton();
    ButtonGroup buttonGroup = new ButtonGroup();
    JComboBox jComboBoxCT = new JComboBox();
    JComboBox jComboBoxST = new JComboBox();
    JLabel jLabelTKind = new JLabel();
    JComboBox jComboBoxTKind = new JComboBox();
    JButton jButtonOk = new JButton();
    JButton jButtonCancel = new JButton();
    public ElementProperty(ElementEx element) {
        super(res.getString("settype"));
        this.element=element;
        try {
            jbInit();
        } catch (Exception ex) {
            ex.printStackTrace();
        }
        this.setSize(300,250);
    }
    private void jbInit() throws Exception {
        this.getContentPane().setLayout(null);
        jRadioButtonST.setText("SimpleType");
        jRadioButtonST.setBounds(new Rectangle(30, 66, 97, 26));
        jRadioButtonST.setSelected(false);
        jRadioButtonCT.setText("ComplexType");
        jRadioButtonCT.setSelected(true);
        jRadioButtonCT.setBounds(new Rectangle(30, 23, 97, 26));
        jRadioButtonAddT.setText(res.getString("addType"));
        jRadioButtonAddT.setBounds(new Rectangle(30, 109, 95, 26));
        jRadioButtonAddT.setSelected(false);
        jRadioButtonST.addActionListener(new ElementProperty_jRadioButton_actionAdapter(this));
        jRadioButtonCT.addActionListener(new ElementProperty_jRadioButton_actionAdapter(this));
        jRadioButtonAddT.addActionListener(new ElementProperty_jRadioButton_actionAdapter(this));
        
        buttonGroup.add(jRadioButtonCT);
        buttonGroup.add(jRadioButtonST);
        buttonGroup.add(jRadioButtonAddT);
        jRadioButtonCT.setSelected(true);
        
        jComboBoxCT.setBounds(new Rectangle(129, 24, 128, 25));
        this.jComboBoxCT.setEnabled(jRadioButtonCT.isSelected());
        
        jComboBoxST.setBounds(new Rectangle(129, 67, 128, 25));
        this.jComboBoxST.setEnabled(jRadioButtonST.isSelected());
        for (Iterator iter = ConstanceSet.getXMLSchemaBuildinTypes().iterator(); iter.hasNext();) {
            String baseType = (String) iter.next();
            jComboBoxST.addItem(baseType);
        }
        if(this.element.getDefinitionEx().getTypes()!=null){
            for (Iterator iter = this.element.getDefinitionEx().getTypes().getExtensibilityElements().iterator(); iter.hasNext();) {
                SchemaEx schemaEx = (SchemaEx) iter.next();
                for (Iterator iterator = schemaEx.getComplexTypes().iterator(); iterator.hasNext();) {
                    ComplexTypeEx complexTypeEx = (ComplexTypeEx) iterator.next();
                    jComboBoxCT.addItem(complexTypeEx.getName());
                }
                for (Iterator iterator = schemaEx.getSimpleTypes().iterator(); iterator.hasNext();) {
                    SimpleTypeEx simpleTypeEx = (SimpleTypeEx) iterator.next();
                    jComboBoxST.addItem(simpleTypeEx.getName());
                }
            }
        }
        jLabelTKind.setText(res.getString("chooseTypeType"));
        jLabelTKind.setBounds(new Rectangle(50, 142, 80, 25));
        jComboBoxTKind.setBounds(new Rectangle(131, 142, 129, 25));
        jComboBoxTKind.setEnabled(jRadioButtonAddT.isSelected());
       
        jComboBoxTKind.addItem("complexType");
        jComboBoxTKind.addItem("simpleType");
        jComboBoxTKind.setSelectedIndex(-1);
        
        jButtonOk.setBounds(new Rectangle(53, 183, 61, 25));
        jButtonOk.setText(res.getString("yes"));
        jButtonOk.addActionListener(new ElementProperty_jButtonOk_actionAdapter(this));
        jButtonCancel.setBounds(new Rectangle(165, 183, 61, 25));
        jButtonCancel.setText(res.getString("no"));
        jButtonCancel.addActionListener(new
                ElementProperty_jButtonCancel_actionAdapter(this));
        this.getContentPane().add(jRadioButtonCT);
        this.getContentPane().add(jComboBoxCT);
        this.getContentPane().add(jRadioButtonST);
        this.getContentPane().add(jComboBoxST);
        this.getContentPane().add(jComboBoxTKind);
        this.getContentPane().add(jRadioButtonAddT);
        this.getContentPane().add(jLabelTKind);
        this.getContentPane().add(jButtonOk);
        this.getContentPane().add(jButtonCancel);
       
    }
    public void jButtonOk_actionPerformed(ActionEvent e) {
        if(jRadioButtonCT.isSelected()){
            this.element.setTypeEx((String) jComboBoxCT.getSelectedItem());
        }
        else if(jRadioButtonST.isSelected()){
            this.element.setTypeEx((String) jComboBoxST.getSelectedItem());
        }
        else if(jRadioButtonAddT.isSelected()){
            if(((String)jComboBoxTKind.getSelectedItem()).equals("simpleType")){
                this.element.addTypeEx(this.element.getDefinitionEx().createSimpleType());
            }
            else if(((String)jComboBoxTKind.getSelectedItem()).equals("complexType")){
                this.element.addTypeEx(this.element.getDefinitionEx().createComplexType());
            }
        }
        this.dispose();
    }
    public void jButtonCancel_actionPerformed(ActionEvent e) {
        this.dispose();
    }
    
    public void jRadioButton_actionPerformed(ActionEvent e) {
        jComboBoxCT.setEnabled(jRadioButtonCT.isSelected());
        jComboBoxST.setEnabled(jRadioButtonST.isSelected());
        jComboBoxTKind.setEnabled(jRadioButtonAddT.isSelected());
    }
}
class ElementProperty_jButtonCancel_actionAdapter implements ActionListener {
    private ElementProperty adaptee;
    ElementProperty_jButtonCancel_actionAdapter(ElementProperty adaptee) {
        this.adaptee = adaptee;
    }
    public void actionPerformed(ActionEvent e) {
        adaptee.jButtonCancel_actionPerformed(e);
    }
}
class ElementProperty_jButtonOk_actionAdapter implements ActionListener {
    private ElementProperty adaptee;
    ElementProperty_jButtonOk_actionAdapter(ElementProperty adaptee) {
        this.adaptee = adaptee;
    }
    public void actionPerformed(ActionEvent e) {
        adaptee.jButtonOk_actionPerformed(e);
    }
}
class ElementProperty_jRadioButton_actionAdapter implements ActionListener{
    private ElementProperty adaptee;
    ElementProperty_jRadioButton_actionAdapter(ElementProperty adaptee) {
        this.adaptee = adaptee;
    }
    
    public void actionPerformed(ActionEvent e) {
        adaptee.jRadioButton_actionPerformed(e);
    }
    
}
