package org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.view.
        propertyeditor;
import java.awt.Rectangle;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;
import java.util.ResourceBundle;
import javax.swing.DefaultListModel;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JTextField;
import javax.swing.SwingConstants;
import org.act.wsc.bpel4wsmodeling.view.resource.ResChoose;
//<p></p><p></p><p></p><p></p>
public class NamespacePropertyEditor extends APropertyEditor {
	 static ResourceBundle res = ResChoose.getLanguage();
    Map namespaces=new HashMap();
    JList jListNS = new JList();
    JLabel jLabelNS = new JLabel();
    JLabel jLabelValue = new JLabel();
    JTextField jTextFieldValue = new JTextField();
    JButton jButtonRemove = new JButton();
    JLabel jLabelPrefix = new JLabel();
    JButton jButtonAdd = new JButton();
    JTextField jTextFieldPrefix = new JTextField();
    JButton jButtonCancel = new JButton();
    JButton jButtonOk = new JButton();
    public NamespacePropertyEditor(Map namespaces) {
        super(res.getString("setNamespace"));
        this.namespaces.putAll(namespaces);
        try {
           jbInit();
       } catch (Exception ex) {
           ex.printStackTrace();
       }
       this.setSize(400,250);
    }
    private void jbInit() throws Exception {
        this.getContentPane().setLayout(null);
        jTextFieldPrefix.setBounds(new Rectangle(50, 74, 107, 24));
        jButtonAdd.setBounds(new Rectangle(174, 74, 47, 25));
        jButtonAdd.setText(">>");
        jButtonAdd.addActionListener(new
                NamespacePropertyEditor_jButtonAdd_actionAdapter(this));
        jLabelPrefix.setHorizontalAlignment(SwingConstants.RIGHT);
        jLabelPrefix.setText("Prefix");
        jLabelPrefix.setBounds(new Rectangle(5, 76, 41, 21));
        jButtonRemove.setBounds(new Rectangle(174, 105, 47, 25));
        jButtonRemove.setText("<<");
        jButtonRemove.addActionListener(new
                NamespacePropertyEditor_jButtonRemove_actionAdapter(this));
        jTextFieldValue.setBounds(new Rectangle(50, 103, 106, 24));
        jLabelValue.setHorizontalAlignment(SwingConstants.RIGHT);
        jLabelValue.setText("URI ");
        jLabelValue.setBounds(new Rectangle(9, 103, 41, 24));
        jButtonCancel.setBounds(new Rectangle(226, 182, 61, 25));
        jButtonCancel.setText(res.getString("no"));
        jButtonCancel.addActionListener(new
                NamespacePropertyEditor_jButtonCancel_actionAdapter(this));
        jButtonOk.setBounds(new Rectangle(114, 182, 61, 25));
        jButtonOk.setText(res.getString("yes"));
        jButtonOk.addActionListener(new
                NamespacePropertyEditor_jButtonOk_actionAdapter(this));
        this.getContentPane().add(jListNS);
        this.getContentPane().add(jLabelNS);
        this.getContentPane().add(jLabelValue);
        this.getContentPane().add(jTextFieldValue);
        this.getContentPane().add(jButtonRemove);
        this.getContentPane().add(jLabelPrefix);
        this.getContentPane().add(jButtonAdd);
        this.getContentPane().add(jTextFieldPrefix);
        this.getContentPane().add(jButtonCancel);
        this.getContentPane().add(jButtonOk);
        jLabelNS.setText("NamespaceText");
        jLabelNS.setBounds(new Rectangle(40, 27, 73, 20));
        jListNS.setBounds(new Rectangle(231, 38, 154, 128));
        jListNS.setModel(new DefaultListModel());
        for (Iterator iter = this.namespaces.keySet().iterator(); iter.hasNext();) {
            String prefix = (String) iter.next();
            String uri=(String)this.namespaces.get(prefix);
            ((DefaultListModel)this.jListNS.getModel()).addElement(prefix+"="+uri);
        }
    }
    public void jButtonOk_actionPerformed(ActionEvent e) {
        this.dispose();
    }
    public void jButtonCancel_actionPerformed(ActionEvent e) {
        this.namespaces=null;
        this.dispose();
    }
    public void jButtonAdd_actionPerformed(ActionEvent e) {
        String prefix=this.jTextFieldPrefix.getText();
        String uri=this.jTextFieldValue.getText();
        if(prefix!=""&&uri!=""){
            this.namespaces.put(this.jTextFieldPrefix.getText(),this.jTextFieldValue.getText());
            ((DefaultListModel)this.jListNS.getModel()).addElement(prefix+"="+uri);
            this.jTextFieldPrefix.setText("");
            this.jTextFieldValue.setText("");
        }
    }
    public void jButtonRemove_actionPerformed(ActionEvent e) {
        int selIndex=this.jListNS.getSelectedIndex();
        if(selIndex!=-1){
            String selItem=(String) ((DefaultListModel)this.jListNS.getModel()).remove(selIndex);
            String prefix=selItem.substring(0,selItem.indexOf('='));
            String value=(String) this.namespaces.remove(prefix);
            this.jTextFieldPrefix.setText(prefix);
            this.jTextFieldValue.setText(value);
        }
    }
    
    public Map getNamespaces() {
        return namespaces;
    }
}
class NamespacePropertyEditor_jButtonRemove_actionAdapter implements
        ActionListener {
    private NamespacePropertyEditor adaptee;
    NamespacePropertyEditor_jButtonRemove_actionAdapter(NamespacePropertyEditor
            adaptee) {
        this.adaptee = adaptee;
    }
    public void actionPerformed(ActionEvent e) {
        adaptee.jButtonRemove_actionPerformed(e);
    }
}
class NamespacePropertyEditor_jButtonAdd_actionAdapter implements
        ActionListener {
    private NamespacePropertyEditor adaptee;
    NamespacePropertyEditor_jButtonAdd_actionAdapter(NamespacePropertyEditor
            adaptee) {
        this.adaptee = adaptee;
    }
    public void actionPerformed(ActionEvent e) {
        adaptee.jButtonAdd_actionPerformed(e);
    }
}
class NamespacePropertyEditor_jButtonCancel_actionAdapter implements
        ActionListener {
    private NamespacePropertyEditor adaptee;
    NamespacePropertyEditor_jButtonCancel_actionAdapter(NamespacePropertyEditor
            adaptee) {
        this.adaptee = adaptee;
    }
    public void actionPerformed(ActionEvent e) {
        adaptee.jButtonCancel_actionPerformed(e);
    }
}
class NamespacePropertyEditor_jButtonOk_actionAdapter implements ActionListener {
    private NamespacePropertyEditor adaptee;
    NamespacePropertyEditor_jButtonOk_actionAdapter(NamespacePropertyEditor
            adaptee) {
        this.adaptee = adaptee;
    }
    public void actionPerformed(ActionEvent e) {
        adaptee.jButtonOk_actionPerformed(e);
    }
}
