
package org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.view.propertyeditor;
import java.util.List;
import java.util.Map;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.DefinitionEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.ElementEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.SimpleTypeEx;

public class PropertyEditorFactory {
    
    public static String showEditor(String propertyName,String title,String initialValue){
        CPropertyEditor editor=new CPropertyEditor(title,propertyName,initialValue);
        editor.show();
        return editor.getInputValue();
    }
    public static String showEditor(String propertyName,String title,String initialValue, List options){
        SPropertyEditor editor=new SPropertyEditor(title,propertyName,initialValue,options);
        editor.show();
        return editor.getInputValue();
    }
    public static String showEditor(String propertyName,String title,String initialValue, List options,boolean isMutiSel){
        MSPropertyEditor editor=new MSPropertyEditor(title,propertyName,initialValue,options);
        editor.show();
        return editor.getInputValue();
    }
    public static Map showNamespacesEditor(Map namespaces){
        NamespacePropertyEditor editor=new NamespacePropertyEditor(namespaces);
        editor.show();
        return editor.getNamespaces();
    } 
    public static void showElementPropertyEditor(ElementEx elementEx){
        ElementProperty editor=new ElementProperty(elementEx);
        editor.show();
    }
    public static void showSimpleTypePropertyEditor(SimpleTypeEx simpleTypeEx){
        SimpleTypePropertyEditor editor=new SimpleTypePropertyEditor(simpleTypeEx);
        editor.show();
    }
    public static boolean showDefinitionPropertyEditor(DefinitionEx definitionEx){
        DefinitionPropertyEditor editor=new DefinitionPropertyEditor(definitionEx);
        editor.show();
        return !editor.isCancel();
    }
}
