
package org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.view.
        propertyeditor;
import java.util.Iterator;
import java.util.List;
import java.util.ResourceBundle;
import javax.swing.JLabel;
import java.awt.*;
import javax.swing.*;
import org.act.wsc.bpel4wsmodeling.view.resource.ResChoose;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

public class SPropertyEditor extends APropertyEditor {
	 ResourceBundle res = ResChoose.getLanguage();
    List selectionValues;
    JLabel jLabel = new JLabel();
    JButton jButtonOk = new JButton();
    JButton jButtonCancel = new JButton();
    JComboBox jComboBox = new JComboBox();
    public SPropertyEditor(String title, String propertyName,
                           String initialValue, List options) {
        super(title, propertyName, initialValue);
        this.selectionValues = options;
        try {
             jbInit();
         } catch (Exception ex) {
             ex.printStackTrace();
         }
    }
    private void jbInit() throws Exception {
        this.getContentPane().setLayout(null);
        jLabel.setHorizontalAlignment(SwingConstants.LEFT);
        jLabel.setText(this.propertyName);
        jLabel.setBounds(new Rectangle(30, 19, 126, 24));
        jComboBox.setBounds(new Rectangle(30, 42, 128, 24));
        for (Iterator iter = this.selectionValues.iterator(); iter.hasNext();) {
            String element = (String) iter.next();
            jComboBox.addItem(element);
        }
        jComboBox.setSelectedIndex(-1);
        if(this.initialValue!=null){
            jComboBox.setSelectedItem(this.initialValue);
        }
        jButtonCancel.setBounds(new Rectangle(102, 79, 56, 25));
        jButtonCancel.setText(res.getString("no"));
        jButtonCancel.addActionListener(new
                SPropertyEditor_jButtonCancel_actionAdapter(this));
        jButtonOk.addActionListener(new SPropertyEditor_jButtonOk_actionAdapter(this));
        this.getContentPane().add(jButtonCancel);
        this.getContentPane().add(jComboBox);
        this.getContentPane().add(jLabel);
        this.getContentPane().add(jButtonOk);
        jButtonOk.setBounds(new Rectangle(32, 77, 56, 27));
        jButtonOk.setText(res.getString("yes"));
    }
    public void jButtonOk_actionPerformed(ActionEvent e) {
        this.inputValue=(String) this.jComboBox.getSelectedItem();
        this.dispose();
    }
    public void jButtonCancel_actionPerformed(ActionEvent e) {
        this.inputValue=null;
        this.dispose();
    }
}
class SPropertyEditor_jButtonCancel_actionAdapter implements ActionListener {
    private SPropertyEditor adaptee;
    SPropertyEditor_jButtonCancel_actionAdapter(SPropertyEditor adaptee) {
        this.adaptee = adaptee;
    }
    public void actionPerformed(ActionEvent e) {
        adaptee.jButtonCancel_actionPerformed(e);
    }
}
class SPropertyEditor_jButtonOk_actionAdapter implements ActionListener {
    private SPropertyEditor adaptee;
    SPropertyEditor_jButtonOk_actionAdapter(SPropertyEditor adaptee) {
        this.adaptee = adaptee;
    }
    public void actionPerformed(ActionEvent e) {
        adaptee.jButtonOk_actionPerformed(e);
    }
}
