
package org.act.wsc.bpel4wsmodeling.view.action;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ResourceBundle;
import javax.swing.JOptionPane;
import org.act.metaset.Metaset;
import org.act.wsc.bpel4wsmodeling.projectdata.*;
import org.act.wsc.bpel4wsmodeling.projectdata.process.CaseFigure;
import org.act.wsc.bpel4wsmodeling.projectdata.process.Figure;
import org.act.wsc.bpel4wsmodeling.projectdata.process.FlowFigure;
import org.act.wsc.bpel4wsmodeling.projectdata.process.OnMessageFigure;
import org.act.wsc.bpel4wsmodeling.projectdata.process.PickFigure;
import org.act.wsc.bpel4wsmodeling.projectdata.process.SwitchFigure;
import org.act.wsc.bpel4wsmodeling.utils.Print;
import org.act.wsc.bpel4wsmodeling.view.gui.MainFrame;
import org.act.wsc.bpel4wsmodeling.view.resource.ResChoose;
import org.act.wsc.bpel4wsmodeling.debug.engine.WSWF;
import org.act.wsc.bpel4wsmodeling.debug.operate.DebugIdToFigure;
import org.act.wsc.bpel4wsmodeling.def.process.Activity;
import org.act.wsc.bpel4wsmodeling.def.process.BPELProcess;
import org.act.wsc.bpel4wsmodeling.def.process.Case;
import org.act.wsc.bpel4wsmodeling.def.process.OnAlarm;
import org.act.wsc.bpel4wsmodeling.def.process.OnMessage;
import org.act.wsc.bpel4wsmodeling.def.process.OtherWise;

public class DelFigureAction implements ActionListener {
	ResourceBundle res = ResChoose.getLanguage(); 
    Figure figure;
    BPELProcess process;
    
    public DelFigureAction(Figure figure) {
        super();
        this.figure = figure;
        this.process = figure.getOwner().getBPELProcess();
    }
    
    public void actionPerformed(ActionEvent e) {
        Metaset metaset=null;
        String debugId = null; debugId = null;
        if (figure.getOwner().isInDebug()) {
            metaset=figure.getParent().getServicesSet();
            if(metaset instanceof Activity){
                debugId=((Activity)metaset).getAtDebugIdValue();
            }
            else if(metaset instanceof Case){
                debugId=((Case)metaset).getAtDebugIdValue();
            }
            else if(metaset instanceof OtherWise){
                debugId=((OtherWise)metaset).getAtDebugIdValue();
            }
            else if(metaset instanceof OnAlarm){
                debugId=((OnAlarm)metaset).getAtDebugIdValue();
            }
            else if(metaset instanceof OnMessage){
                debugId=((OnMessage)metaset).getAtDebugIdValue();
            }
                        if (debugId!=null&&!WSWF.inStack(debugId)) {
                Print.showMessage(res.getString("cannotremoveactivityactivityexecuted"),Print.MESSAGE_TYPE_WARNING);
                JOptionPane.showMessageDialog(MainFrame.getmainFrame(),
                        res.getString("cannotAddremoveactivity"), res.getString("warning"), JOptionPane.ERROR_MESSAGE);
                return;
            }
        }
        if (figure.getParent() != null) {             if (figure instanceof CaseFigure
                    && figure.getParent() instanceof SwitchFigure) {
                if (((SwitchFigure) figure.getParent()).getCaseCount() == 1) {
                    Print.showMessage(res.getString("cannotdeleteaction_switch"),Print.MESSAGE_TYPE_WARNING);
                    JOptionPane.showMessageDialog(MainFrame.getmainFrame(),
                            res.getString("switchiIncludeCase"));
                    return;
                }
            }
            if (figure instanceof OnMessageFigure
                    && figure.getParent() instanceof PickFigure) {
                if (((PickFigure) figure.getParent()).getOnMessageCount() == 1) {
                    Print.showMessage(res.getString("dele_fail_pick"),Print.MESSAGE_TYPE_WARNING);
                    JOptionPane.showMessageDialog(MainFrame.getmainFrame(),
                            res.getString("pickIncludeOnmessage"));
                    return;
                }
            }
            if (figure.getParent() instanceof FlowFigure) {
                if (figure.getParent().getFigures().size() == 1) {
                    Print.showMessage(res.getString("deleteActivityFail"),Print.MESSAGE_TYPE_WARNING);
                    JOptionPane.showMessageDialog(MainFrame.getmainFrame(),
                            res.getString("flowIncludeActivity"));
                    return;
                }
            }
            figure.getParent().removeFigure(figure);
            figure.getParent().getServicesSet().remove(figure.getServicesSet());
            if (figure.getOwner().isInDebug()) {
                WSWF.replace(metaset,debugId);
            }
            this.process.write();
            if (figure.getServicesSet() instanceof Activity) {
                Activity activity = (Activity) figure.getServicesSet();
                Print.showMessage(res.getString("action")+activity.getName()+"("+activity.getAtNameValue()+")"+res.getString("deleted"));
            }
            else{
                Print.showMessage(res.getString("label")+figure.getServicesSet().getName()+res.getString("deleted"));
            }
        } else if (figure.getOwner() != null) {             figure.getOwner().setMainFigure(null);
            this.process.deleteactivity((Activity) figure.getServicesSet());
            this.process.write();
        }
    }
}
