package org.act.wsc.bpel4wsmodeling.view.action;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import org.act.wsc.bpel4wsmodeling.projectdata.Project;
import org.act.wsc.bpel4wsmodeling.utils.Print;
import org.act.wsc.bpel4wsmodeling.view.processassist.NewPartner;
import org.act.wsc.bpel4wsmodeling.view.resource.ResChoose;
import java.awt.Dimension;
import java.awt.Toolkit;
import java.util.ResourceBundle;
//<p></p><p></p><p></p><p></p>
public class ImportUDDIWSDLAction
    implements ActionListener {
	ResourceBundle res = ResChoose.getLanguage();
    Project project;
  public ImportUDDIWSDLAction(Project pro) {
      this.project=pro;
  }
  
  public void actionPerformed(ActionEvent e) {
    NewPartner dialog;
    dialog = new NewPartner(res.getString("serviceQuery"), true);
    dialog.pack();
    dialog.setSize(400, 180);
    Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
    Dimension dlgSize = dialog.getSize();
    if (dlgSize.height > screenSize.height) {
      dlgSize.height = screenSize.height;
    }
    if (dlgSize.width > screenSize.width) {
      dlgSize.width = screenSize.width;
    }
    dialog.setLocation( (screenSize.width - dlgSize.width) / 2,
                       (screenSize.height - dlgSize.height) / 2);
    dialog.show();
    String wsdlurl = dialog.getInstanceURL();
    if (wsdlurl != null) {
      try {
               if(this.project .importWSDL("uddi", wsdlurl)){           Print.showMessage(res.getString("wsdlInUddi")+" " +wsdlurl+" "+res.getString("imported"));    
       }else{
           Print.showMessage(res.getString("importwsdlfromUDDI")+" "+wsdlurl+" "+res.getString("fail"),Print.MESSAGE_TYPE_ERROR);
       }
      }
      catch (Exception e1) {
          Print.showMessage(res.getString("error_importwsdlfromuddi"),Print.MESSAGE_TYPE_FATAL_ERROR);
      }
    }
  }
}
