
package org.act.wsc.bpel4wsmodeling.view.action;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ResourceBundle;
import javax.swing.JOptionPane;
import org.act.wsc.bpel4wsmodeling.projectdata.Project;
import org.act.wsc.bpel4wsmodeling.projectdata.WorkSpace;
import org.act.wsc.bpel4wsmodeling.view.gui.MainFrame;
import org.act.wsc.bpel4wsmodeling.view.resource.ResChoose;

public class QuitAppAction implements ActionListener {
	ResourceBundle res = ResChoose.getLanguage();
    
    public QuitAppAction() {
        super();
            }
    
    public void actionPerformed(ActionEvent e) {
        this.quitApp();
    }
    public void quitApp(){
		Project project=WorkSpace.getInstance().getActiveProject();
		if(project!=null){
		    int reply=JOptionPane.showConfirmDialog(MainFrame.getmainFrame(),res.getString("saveTheprojectnow"),res.getString("saveprojectMes"),JOptionPane.YES_NO_CANCEL_OPTION,JOptionPane.QUESTION_MESSAGE);
		    if(reply==JOptionPane.YES_OPTION){
		        WorkSpace.getInstance().saveProject(project);
		        WorkSpace.getInstance().closeProject(project);
		        Project nextProject=WorkSpace.getInstance().getNextProject(project);
		        if(nextProject!=null){
		            WorkSpace.getInstance().openProject(nextProject);
		        }
		    }else if(reply==JOptionPane.NO_OPTION){
		        WorkSpace.getInstance().closeProject(project);
		        Project nextProject=WorkSpace.getInstance().getNextProject(project);
		        if(nextProject!=null){
		            WorkSpace.getInstance().openProject(nextProject);
		        }
		    }
		    else if(reply==JOptionPane.CANCEL_OPTION){
		        return;
		    }
		}
		MainFrame.getmainFrame().dispose();
		System.exit(0);
    }
}
