
package org.act.wsc.bpel4wsmodeling.view.graphic;
import java.awt.event.MouseEvent;
import javax.swing.event.MouseInputListener;
import org.act.wsc.bpel4wsmodeling.projectdata.process.DataFactory;
import org.act.wsc.bpel4wsmodeling.projectdata.process.Figure;
import org.act.wsc.bpel4wsmodeling.projectdata.process.GraphLayer;
import org.act.wsc.bpel4wsmodeling.view.gui.MainFrame;

public class GraphLayerController
    implements MouseInputListener {
GraphLayerClicker processClicker;
  
  public GraphLayerController(GraphLayerViewer myViewer, GraphLayer myLayer) {
    super();
    this.myViewer = myViewer;
    this.myLayer = myLayer;
    processClicker=new GraphLayerClicker(myViewer);
  }
  GraphLayerViewer myViewer;
  GraphLayer myLayer;
  
  public void mouseClicked(MouseEvent e) {
        if (e.getButton() == 1 && e.getClickCount() == 1) {
            processClicker.singleClicked(e);
    } else if (e.getButton() == 1 && e.getClickCount() == 2) {
           processClicker.doubleClicked(e);
    } else if (e.getButton() == 3) {
            processClicker.rightClicked(e);
    }
  }
  
  public void mouseEntered(MouseEvent e) {
      }
  
  public void mouseExited(MouseEvent e) {
      }
  
  public void mousePressed(MouseEvent e) {
      }
  
  public void mouseReleased(MouseEvent e) {
        Figure newFigure = null;
    if(myLayer.getMainFigure()==null){
    	           newFigure = DataFactory.createFigureByType(MainFrame.getmainFrame().
                                                   editPane.toolBar.getFigureType(),
                                                   e.getX(), e.getY());
        if(newFigure!=null){
        	this.myLayer.setMainFigure(newFigure);
        }
    }
  }
  
  public void mouseDragged(MouseEvent e) {
      }
  
  public void mouseMoved(MouseEvent e) {
      }
}
