
package org.act.wsc.bpel4wsmodeling.view.graphic.leftbuttonproperty;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.util.List;
import java.util.ResourceBundle;
import java.util.Vector;
import javax.swing.DefaultCellEditor;
import javax.swing.JComboBox;
import javax.swing.JTextField;
import org.act.wsc.bpel4wsmodeling.def.process.Copy;
import org.act.wsc.bpel4wsmodeling.def.process.Correlation;
import org.act.wsc.bpel4wsmodeling.def.process.Transaction;
import org.act.wsc.bpel4wsmodeling.def.process.Variable;
import org.act.wsc.bpel4wsmodeling.projectdata.Project;
import org.act.wsc.bpel4wsmodeling.projectdata.process.Figure;
import org.act.wsc.bpel4wsmodeling.view.graphic.table.EachRowEditor;
import org.act.wsc.bpel4wsmodeling.view.graphic.table.EachRowRenderer;
import org.act.wsc.bpel4wsmodeling.view.gui.MainFrame;
import org.act.wsc.bpel4wsmodeling.view.resource.ResChoose;

public class TransactionProperty extends AbstractActProperty {
	ResourceBundle res = ResChoose.getLanguage();
    Transaction transaction;
    JTextField jTextFieldTransactionSet;
    JComboBox jComboxAction;
    JComboBox jComboxOutVar;
    JTextField jTextFieldCor;
    String transactionSetName = null;
    String action = null;
    String variableOut = null;
    String coordinator = null;
    String name = null;
    String joinCondition = null;
    String suppressJoinFailure = null;
    MainFrame frame = MainFrame.getmainFrame();
    Project project;
    
    public TransactionProperty(Figure f) {
        super(f);
                transaction = (Transaction) this.act;
        project = this.frame.getProject();
        initAttTable();
    }
    
    public void setAttTable() {
                List it6 = new Vector();
        List it7 = new Vector();
        List it8 = new Vector();
        int j6 = this.comBoxsuppressJoinFailure.getActionListeners().length - 1;
        int j7 = this.jComboxAction.getActionListeners().length - 1;
        int j8 = this.jComboxOutVar.getActionListeners().length - 1;
        for (int i = j6; i >= 0; i--) {
            ActionListener it = this.comBoxsuppressJoinFailure
                    .getActionListeners()[i];
            it6.add(it);
            this.comBoxsuppressJoinFailure.removeActionListener(it);
        }
        for (int i = j7; i >= 0; i--) {
            ActionListener it = this.jComboxAction.getActionListeners()[i];
            it7.add(it);
            this.jComboxAction.removeActionListener(it);
        }
        for (int i = j8; i >= 0; i--) {
            ActionListener it = this.jComboxOutVar.getActionListeners()[i];
            it8.add(it);
            this.jComboxOutVar.removeActionListener(it);
        }
        comBoxsuppressJoinFailure.removeAllItems();
        this.jComboxAction.removeAllItems();
        this.jComboxOutVar.removeAllItems();
        comBoxsuppressJoinFailure.addItem("yes");
        comBoxsuppressJoinFailure.addItem("no");
        this.jComboxAction.addItem("begin");
        this.jComboxAction.addItem("confirm");
        this.jComboxAction.addItem("cancel");
        List tempvs=figure.getVariableList();
            for (int i = 0; i < tempvs.size(); i++) {
                Variable v = (Variable) tempvs.get(i);
                String variablename = v.getAtNameValue();
                this.jComboxOutVar.addItem(variablename);
            }
        if (this.transaction != null) {
            this.txtname.setText(this.name);
            this.txtjoinCondition.setText(this.joinCondition);
            for (int f = 0; f < this.comBoxsuppressJoinFailure.getItemCount(); f++) {
                String txtcon = (String) this.comBoxsuppressJoinFailure
                        .getItemAt(f);
                if (this.suppressJoinFailure.equals(txtcon)) {
                    this.comBoxsuppressJoinFailure.setSelectedIndex(f);
                    break;
                }
            }
            this.jTextFieldTransactionSet.setText(this.transactionSetName);
            for (int f = 0; f < this.jComboxAction.getItemCount(); f++) {
                String txtaction = (String) this.jComboxAction.getItemAt(f);
                if (this.action.equals(txtaction)) {
                    this.jComboxAction.setSelectedIndex(f);
                    break;
                }
            }
            for (int f = 0; f < this.jComboxOutVar.getItemCount(); f++) {
                String var = (String) this.jComboxOutVar.getItemAt(f);
                if (this.action.equals(var)) {
                    this.jComboxOutVar.setSelectedIndex(f);
                    break;
                }
            }
            this.jTextFieldCor.setText(this.coordinator);
        }
        for (int i = 0; i < it6.size(); i++) {
            ActionListener it = (ActionListener) it6.get(i);
            ;
            this.comBoxsuppressJoinFailure.addActionListener(it);
        }
        for (int i = 0; i < it7.size(); i++) {
            ActionListener it = (ActionListener) it7.get(i);
            ;
            this.jComboxAction.addActionListener(it);
        }
        for (int i = 0; i < it8.size(); i++) {
            ActionListener it = (ActionListener) it8.get(i);
            ;
            this.jComboxOutVar.addActionListener(it);
        }
    }
    
    void initAttTable() {
                this.name = this.transaction.getAtNameValue();
        this.joinCondition = this.transaction.getAtJoinConditionValue();
        this.suppressJoinFailure = this.transaction
                .getAtsuppressJoinFailureValue();
        this.transactionSetName = this.transaction.getAtTransactionSetValue();
        this.action = this.transaction.getAtActionValue();
        this.variableOut = this.transaction.getAtOutVarValue();
        coordinator = this.transaction.getAtCoordinatorValue();
        defaultAttTableModel.setDataVector(new Object[][] { { "name", name },
                { "joinCondition", joinCondition },
                { "suppressJoinFailure", suppressJoinFailure },
                { "transactionName", transactionSetName },
                { "action", action }, { "outputVariable", variableOut },
                { "coordinator", coordinator }
        }, new Object[] { res.getString("propertyname"), res.getString("propertyvalue") });
                txtname = new JTextField();
        this.txtjoinCondition = new JTextField();
        this.comBoxsuppressJoinFailure = new JComboBox();
        this.jTextFieldTransactionSet = new JTextField();
        this.jComboxAction = new JComboBox();
        this.jComboxOutVar = new JComboBox();
        this.jTextFieldCor = new JTextField();
        txtname.addKeyListener(new KeyListener() {
            public void keyPressed(KeyEvent e) {
                if (e.getKeyCode() == KeyEvent.VK_ENTER) {
                    act.setAtNameValue(txtname.getText());
                    process.write();
                }
            }
            public void keyReleased(KeyEvent e) {
            }
            public void keyTyped(KeyEvent e) {
            }
        });
        txtjoinCondition.addKeyListener(new KeyListener() {
            public void keyPressed(KeyEvent e) {
                if (e.getKeyCode() == KeyEvent.VK_ENTER) {
                    act.setAtJoinConditionValue(txtjoinCondition.getText());
                    process.write();
                }
            }
            public void keyReleased(KeyEvent e) {
            }
            public void keyTyped(KeyEvent e) {
            }
        });
        this.comBoxsuppressJoinFailure.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                if (e.getSource().equals(comBoxsuppressJoinFailure)) {
                    act.setAtSuppressJoinFailureValue(comBoxsuppressJoinFailure
                            .getSelectedItem().toString());
                    process.write();
                }
            }
        });
        this.jTextFieldTransactionSet.addKeyListener(new KeyListener() {
            public void keyPressed(KeyEvent e) {
                if (e.getKeyCode() == KeyEvent.VK_ENTER) {
                    transaction
                            .setAtTransactionSetValue(jTextFieldTransactionSet
                                    .getText());
                    process.write();
                }
            }
            public void keyReleased(KeyEvent e) {
            }
            public void keyTyped(KeyEvent e) {
            }
        });
        this.jComboxAction.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                if (e.getSource().equals(jComboxAction)) {
                    transaction.setAtActionValue(jComboxAction
                            .getSelectedItem().toString());
                    process.write();
                }
            }
        });
        this.jComboxOutVar.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                if (e.getSource().equals(jComboxOutVar)) {
                    transaction.setAtOutVarValue(jComboxOutVar
                            .getSelectedItem().toString());
                    process.write();
                }
            }
        });
        this.jTextFieldCor.addKeyListener(new KeyListener() {
            public void keyPressed(KeyEvent e) {
                if (e.getKeyCode() == KeyEvent.VK_ENTER) {
                    transaction.setAtCoordinatorValue(jTextFieldCor.getText());
                    process.write();
                }
            }
            public void keyReleased(KeyEvent e) {
            }
            public void keyTyped(KeyEvent e) {
            }
        });
        
        EachRowRenderer rowRenderer = new EachRowRenderer();
        
        EachRowEditor rowEditor = new EachRowEditor(jAttTable);
        DefaultCellEditor txtnameEditor = new DefaultCellEditor(txtname);
        DefaultCellEditor txtJoinConditionEditor = new DefaultCellEditor(
                txtjoinCondition);
        DefaultCellEditor txtSuppressJoinFailureEditor = new DefaultCellEditor(
                comBoxsuppressJoinFailure);
        DefaultCellEditor txtTransactionSetEditor = new DefaultCellEditor(
                this.jTextFieldTransactionSet);
        DefaultCellEditor comBoxActionEditor = new DefaultCellEditor(
                this.jComboxAction);
        DefaultCellEditor comBoxOutVarEditor = new DefaultCellEditor(
                this.jComboxOutVar);
        DefaultCellEditor txtCorEditor = new DefaultCellEditor(
                this.jTextFieldCor);
        rowEditor.setEditorAt(0, txtnameEditor);
        rowEditor.setEditorAt(1, txtJoinConditionEditor);
        rowEditor.setEditorAt(2, txtSuppressJoinFailureEditor);
        rowEditor.setEditorAt(3, txtTransactionSetEditor);
        rowEditor.setEditorAt(4, comBoxActionEditor);
        rowEditor.setEditorAt(5, comBoxOutVarEditor);
        rowEditor.setEditorAt(6, txtCorEditor);
        this.jAttTable.getColumn(res.getString("propertyvalue")).setCellRenderer(rowRenderer);
        this.jAttTable.getColumn(res.getString("propertyvalue")).setCellEditor(rowEditor);
    }
    
    public void correlatinNameUpdate(Correlation c, String s) {
            }
    
    public void addCopy(Copy c) {
            }
    
    public void deleteCopy(Copy c) {
            }
    
    public void addCorrelation(Correlation c) {
            }
    
    public void deleteCorrelation(Correlation correlation) {
            }
}
