
package org.act.wsc.bpel4wsmodeling.view.graphic.rightbuttonmenu;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ResourceBundle;
import javax.swing.JMenuItem;
import javax.swing.JOptionPane;
import org.act.wsc.bpel4wsmodeling.debug.engine.WSWF;
import org.act.wsc.bpel4wsmodeling.def.process.Activity;
import org.act.wsc.bpel4wsmodeling.projectdata.process.Figure;
import org.act.wsc.bpel4wsmodeling.projectdata.process.OnAlarmFigure;
import org.act.wsc.bpel4wsmodeling.projectdata.process.OnMessageFigure;
import org.act.wsc.bpel4wsmodeling.projectdata.process.PickFigure;
import org.act.wsc.bpel4wsmodeling.view.gui.MainFrame;
import org.act.wsc.bpel4wsmodeling.view.resource.ResChoose;

public class PickRightMenu extends AbstractRightMenu {
	 
	 ResourceBundle res = ResChoose.getLanguage();
	private JMenuItem addOnMessageItem=new JMenuItem(res.getString("addOnMessage"));
	private JMenuItem addOnAlarmItem=new JMenuItem(res.getString("addOnAlarm"));
	
	public PickRightMenu(Figure f) {
		super(f);
		this.add(this.addOnMessageItem);
		this.add(this.addOnAlarmItem);
		this.addOnMessageItem.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e) {
			    String debugId=null;
			    			    if (figure.getOwner().isInDebug()&&figure.getServicesSet() instanceof Activity) {
                    Activity activity = (Activity) figure.getServicesSet();
                    debugId=activity.getAtDebugIdValue();
                                        if(!WSWF.inStack(debugId)){
                        JOptionPane.showMessageDialog(MainFrame.getmainFrame(),res.getString("cannotAddremoveactivity"),res.getString("warning"),JOptionPane.ERROR_MESSAGE);;
                        return;
                    }
                }
			    ((PickFigure)PickRightMenu.this.figure).addFigure(new OnMessageFigure());
				if(figure.getOwner().isInDebug()){
				    WSWF.replace(figure.getServicesSet(),debugId);
				}
			}		
		});
		this.addOnAlarmItem.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e) {
			    String debugId=null;
			    if (figure.getOwner().isInDebug()&&figure.getServicesSet() instanceof Activity) {
                    Activity activity = (Activity) figure.getServicesSet();
                    debugId=activity.getAtDebugIdValue();
                                        if(!WSWF.inStack(debugId)){
                        JOptionPane.showMessageDialog(MainFrame.getmainFrame(),res.getString("cannotAddremoveactivity"),res.getString("warning"),JOptionPane.ERROR_MESSAGE);;
                        return;
                    }
                }
			    ((PickFigure)PickRightMenu.this.figure).addFigure(new OnAlarmFigure());
				if(figure.getOwner().isInDebug()){
				    WSWF.replace(figure.getServicesSet(),debugId);
				}
			}		
		});
	}
}
