
package org.act.wsc.bpel4wsmodeling.view.graphic.rightbuttonmenu;
import java.util.ResourceBundle;
import javax.swing.JMenuItem;
import org.act.wsc.bpel4wsmodeling.projectdata.process.Figure;
import org.act.wsc.bpel4wsmodeling.view.action.CreatCorrelationSetAction;
import org.act.wsc.bpel4wsmodeling.view.action.CreateVariableAction;
import org.act.wsc.bpel4wsmodeling.view.resource.ResChoose;

public class ScopeRightMenu extends AbstractRightMenu {
	 
	 ResourceBundle res = ResChoose.getLanguage();
    JMenuItem addVariable=new JMenuItem(res.getString("addVariable"));
    JMenuItem addCorrelationSet=new JMenuItem(res.getString("addCorrelationSet"));
    
    public ScopeRightMenu(Figure figure) {
        super(figure);
        this.addSeparator();
        this.add(addVariable);
        this.add(addCorrelationSet);
        addVariable.addActionListener(new CreateVariableAction(figure));
        addCorrelationSet.addActionListener(new CreatCorrelationSetAction(figure));
    }
}
