package org.act.wsc.bpel4wsmodeling.view.gui;
import java.awt.Rectangle;
import java.awt.event.ActionEvent;
import java.io.File;
import java.util.ResourceBundle;
import javax.swing.BorderFactory;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JFileChooser;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JTextArea;
import javax.swing.JTextField;
import org.act.wsc.bpel4wsmodeling.projectdata.WorkSpace;
import org.act.wsc.bpel4wsmodeling.utils.Print;
import org.act.wsc.bpel4wsmodeling.view.resource.ResChoose;
//<p></p><p></p><p></p><p></p>
public class NewProjectDialog
    extends JDialog {
  JPanel panel1 = new JPanel();
  JLabel jLabelProject = new JLabel();
  JTextField jTxtName = new JTextField();
  JLabel jLabelProjectDes = new JLabel();
  JTextArea jTextAreaProjectDes = new JTextArea();
  JLabel jLabelPath = new JLabel();
  JTextField jTxtPath = new JTextField();
  JButton jBtnPath = new JButton();
  JButton btnOk = new JButton();
  JButton btnCancel = new JButton();
  public boolean bCanceled = true;
  private String name = null;
  private String projectMemo = null;
  private String filePath = null;
  private MainFrame frame_;
  public String filename;   ResourceBundle res = ResChoose.getLanguage();
  public NewProjectDialog(MainFrame frame, String title) {
    super(frame, title, true);
    this.frame_ = frame;
    try {
      jbInit();
      pack();
    }
    catch (Exception ex) {
      ex.printStackTrace();
    }
  }
  private void jbInit() throws Exception {
    panel1.setLayout(null);
    this.getContentPane().setLayout(null);
    panel1.setBounds(new Rectangle(2, 1, 400, 244));
    this.jLabelProject.setText(res.getString("projectName"));
    this.jLabelProject.setBounds(new Rectangle(22, 26, 54, 21));
    this.jTxtName.setBounds(new Rectangle(96, 25, 272, 24));
    this.jTxtName.setText("untitled");
    this.jLabelProjectDes.setText(res.getString("projectDescription"));
    this.jLabelProjectDes.setBounds(new Rectangle(22, 66, 53, 18));
    this.jTextAreaProjectDes.setBorder(BorderFactory.createLoweredBevelBorder());     this.jTextAreaProjectDes.setText(res.getString("write_projectDescription"));
    this.jTextAreaProjectDes.setBounds(new Rectangle(94, 65, 271, 37));
    this.jTxtPath.setBounds(new Rectangle(94, 65, 271, 37));
    this.jLabelPath.setText(res.getString("projectLocatian"));
    this.jLabelPath.setBounds(new Rectangle(23, 127, 65, 22));
    this.jTxtPath.setBounds(new Rectangle(94, 126, 233, 27));
    this.jTxtPath.addActionListener(new
                                    NewProjectDialog_txtFilePath_actionAdapter(this));
    jBtnPath.setBounds(new Rectangle(333, 125, 59, 30));
    jBtnPath.setText(res.getString("scan"));
    jBtnPath.addActionListener(new NewProjectDialog_btnPath_actionAdapter(this));
    btnOk.setBounds(new Rectangle(68, 194, 82, 28));
    btnOk.setText(res.getString("newProjectDialog_yes"));
    btnOk.addActionListener(new NewProjectDialog_btnOk_actionAdapter(this));
    btnCancel.setBounds(new Rectangle(249, 195, 82, 29));
    btnCancel.setText(res.getString("newProjectDialog_no"));
    btnCancel.addActionListener(new NewProjectDialog_btnCancel_actionAdapter(this));
    panel1.add(this.jLabelProject, null);
    panel1.add(this.jTxtName, null);
    panel1.add(this.jLabelProjectDes, null);
    panel1.add(this.jTextAreaProjectDes, null);
    panel1.add(this.jLabelPath, null);
    panel1.add(this.jTxtPath, null);
    panel1.add(this.jBtnPath, null);
    panel1.add(btnOk, null);
    panel1.add(btnCancel, null);
    this.getContentPane().add(panel1, null);
  }
    public boolean isUserCanceled() {
    return bCanceled;
  }
    public String getProjectName() {
    return this.name;
  }
    public String getProjectDescription() {
    return this.projectMemo;
  }
    public String getProjectRootPath() {
    return this.filePath;
  }
    void txtFilePath_actionPerformed(ActionEvent e) {
  }
  void btnOk_actionPerformed(ActionEvent e) {
      if(WorkSpace.getInstance().getProjects().containsKey(this.jTxtName.getText())||new File(this.jTxtPath.getText()+File.separator+this.jTxtName.getText()).exists()){
          Print.showMessage(res.getString("failure"),Print.MESSAGE_TYPE_ERROR);
          JOptionPane.showMessageDialog(this, res.getString("project_exist_createAgain"), res.getString("project_exist"),
                  JOptionPane.WARNING_MESSAGE);
          return;
      }else{
          this.bCanceled = false;
          if (this.jTxtName.getText() != null &&
              this.jTxtName.getText().length() != 0) {
            this.name = this.jTxtName.getText();
          }
          if (this.jTextAreaProjectDes.getText() != null &&
              this.jTextAreaProjectDes.getText().length() != 0 &&
              !this.jTextAreaProjectDes.getText().equals(res.getString("write_projectDescription"))) {
            this.projectMemo = this.jTextAreaProjectDes.getText();
          }
          else {
            this.projectMemo = this.jTextAreaProjectDes.getText();
          }
          if (this.jTxtPath.getText() != null &&
              this.jTxtPath.getText().length() != 0) {
            this.filePath = this.jTxtPath.getText();
          }
          this.dispose();
      }
     
  }
    void btnCancel_actionPerformed(ActionEvent e) {
    this.bCanceled = true;
    this.dispose();
  }
  void btnPath_actionPerformed(ActionEvent e) {
    File path;
    String projectDir = null;
    
    
    if (projectDir == null) {
      
      JFileChooser fileChooser = new JFileChooser(System.getProperty("user.dir"));
      fileChooser.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
      int state = fileChooser.showOpenDialog(MainFrame.getmainFrame());
      if (state == JFileChooser.APPROVE_OPTION) {
        
        this.jTxtPath.setText(fileChooser.getSelectedFile().getAbsolutePath());
      }
    }
  }
  class NewProjectDialog_txtFilePath_actionAdapter
      implements java.awt.event.ActionListener {
    NewProjectDialog adaptee;
    NewProjectDialog_txtFilePath_actionAdapter(NewProjectDialog adaptee) {
      this.adaptee = adaptee;
    }
    public void actionPerformed(ActionEvent e) {
      adaptee.txtFilePath_actionPerformed(e);
    }
  }
  class NewProjectDialog_btnOk_actionAdapter
      implements java.awt.event.ActionListener {
    NewProjectDialog adaptee;
    NewProjectDialog_btnOk_actionAdapter(NewProjectDialog adaptee) {
      this.adaptee = adaptee;
    }
    public void actionPerformed(ActionEvent e) {
      adaptee.btnOk_actionPerformed(e);
    }
  }
  class NewProjectDialog_btnCancel_actionAdapter
      implements java.awt.event.ActionListener {
    NewProjectDialog adaptee;
    NewProjectDialog_btnCancel_actionAdapter(NewProjectDialog adaptee) {
      this.adaptee = adaptee;
    }
    public void actionPerformed(ActionEvent e) {
      adaptee.btnCancel_actionPerformed(e);
    }
  }
  class NewProjectDialog_btnPath_actionAdapter
      implements java.awt.event.ActionListener {
    NewProjectDialog adaptee;
    NewProjectDialog_btnPath_actionAdapter(NewProjectDialog adaptee) {
      this.adaptee = adaptee;
    }
    public void actionPerformed(ActionEvent e) {
      adaptee.btnPath_actionPerformed(e);
    }
  }
}
class NewProjectDialog_btnOk_actionAdapter
    implements java.awt.event.ActionListener {
  NewProjectDialog adaptee;
  NewProjectDialog_btnOk_actionAdapter(NewProjectDialog adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.btnOk_actionPerformed(e);
  }
}
